#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <dos.h>
#include "2draw.h"
#include "pragmas.h"

#define AVERAGEFRAMES 64
static long frameval[AVERAGEFRAMES], numframes = 0;

#define NUMOPTIONS 8
#define NUMKEYS 19
static long chainxres[4] = {256,320,360,400};
static long chainyres[11] = {200,240,256,270,300,350,360,400,480,512,540};
static long vesares[13][2] = {320,200,360,200,320,240,360,240,320,400,
									360,400,640,350,640,400,640,480,800,600,
									1024,768,1280,1024,1600,1200};
static char option[NUMOPTIONS] = {0,0,0,0,0,0,1,0};
static char keys[NUMKEYS] =
{
	0xc8,0xd0,0xcb,0xcd,0x2a,0x9d,0x1d,0x39,
	0x1e,0x2c,0xd1,0xc9,0x47,0x49,
	0x9c,0x1c,0xd,0xc,0xf,
};

void (__interrupt __far *oldtimerhandler)();
void __interrupt __far timerhandler(void);

char boardfilename[13];
short boardnum = 0;
long searchx, searchy;

static long lockclock;

static char tempbuf[64];

static char textmessage[41];
static long textmessagetime = 0x80000000;

static short mousx, mousy, mstrafe;
static char bstatus, obstatus;

static char needtosavepicanm;

static short localartfreq[MAXTILES];
static short localartlookup[MAXTILES], localartlookupnum;

static char palette[768];
static unsigned char xfillbuf[2048], yfillbuf[2048];
static short tempboard2d[4096];

static long posx, posy, zoom;
static short ang, vel, svel, angvel, zoomvel;
static long gettilezoom = 1, strafemode = 0, whitecol;

static long startposx, startposy, startzoom;
static short startang;

extern char picsiz[MAXTILES];

extern char chainstat;
extern long chainplace, frameplace;

extern char editstatus;

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux copybuf =\
	"rep movsd",\
	parm [esi][edi][ecx]\

#pragma aux scale =\
	"imul ebx",\
	"idiv ecx",\
	parm [eax][ebx][ecx]\
	modify [eax edx]\

#pragma aux mulscale =\
	"imul ebx",\
	"shrd eax, edx, cl",\
	parm [eax][ebx][ecx]\
	modify [edx]\

#pragma aux boundmulscale =\
	"imul ebx",\
	"mov ebx, edx",\
	"shrd eax, edx, cl",\
	"sar edx, cl",\
	"xor edx, eax",\
	"js checkit",\
	"xor edx, eax",\
	"jz skipboundit",\
	"cmp edx, 0xffffffff",\
	"je skipboundit",\
	"checkit:",\
	"mov eax, ebx",\
	"sar eax, 31",\
	"add eax, 0x80000000",\
	"not eax",\
	"skipboundit:",\
	parm [eax][ebx][ecx]\
	modify [edx]\

#pragma aux divscale =\
	"cdq",\
	"shld edx, eax, cl",\
	"sal eax, cl",\
	"idiv ebx",\
	parm [eax][ebx][ecx]\
	modify [edx]\

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"sal dx, 1",\
	"mov mousx, cx",\
	"mov mousy, dx",\
	"mov ax, 5d",\
	"int 33h",\
	"mov ah, bstatus",\
	"mov obstatus, ah",\
	"mov bstatus, al",\
	modify [eax ebx ecx edx]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux limitrate =\
	"mov dx, 0x3da",\
	"wait1: in al, dx",\
	"test al, 8",\
	"jnz wait1",\
	"wait2: in al, dx",\
	"test al, 8",\
	"jz wait2",\

main(short int argc,char **argv)
{
	char ch;
	short searchsprite;
	long searchspritestartx, searchspritestarty;
	long i, j, k, m, fil, cosang, sinang, x, y, x2, y2, sx, sy;
	long somethingintab, temppicnum, tempzoom, tempang, c, d;
	long boardplc, templong, asksave, markx, marky, markxlen, markylen;

	editstatus = 1;

	if ((fil = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&option[0],NUMOPTIONS);
		read(fil,&keys[0],NUMKEYS);
		close(fil);
	}
	if (option[4] > 0) option[4] = 0;
	initmouse();

	switch(option[0])
	{
		case 0: init2draw(0,chainxres[option[6]&15],chainyres[option[6]>>4]); break;
		case 1: init2draw(1,vesares[option[6]&15][0],vesares[option[6]&15][1]); break;
		default: init2draw(option[0],320L,200L); break;
	}
	inittimer();

	if ((i = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(i,&palette[0],768);
		close(i);
	}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);

	k = 0; m = 0;
	for(i=0;i<256;i++)
	{
		j = (long)(palette[m+0]+palette[m+1]+palette[m+2]);
		if (j > k) k = j, whitecol = i;
		m += 3;
	}

	loadpics("tiles000.art");
	if (argc >= 2)
	{
		strcpy(&boardfilename,argv[1]);
		if(strchr(boardfilename,'.') == 0)
			strcat(boardfilename,".map");
	}
	else
		strcpy(&boardfilename,"boards.map");

	load2board(boardfilename,boardnum,&startposx,&startposy,&startzoom,&startang);
	posx = startposx; posy = startposy; zoom = startzoom; ang = startang;

	sprintf(textmessage,"Map %d",boardnum);
	textmessagetime = totalclock+360;

	needtosavepicanm = 0;
	asksave = 0;
	somethingintab = 0;
	searchx = pivotx;
	searchy = pivoty;
	searchsprite = -1;
	bstatus = 0;
	obstatus = 0;
	markx = 0;
	marky = 0;
	markxlen = 0;
	markylen = 0;

	while (keystatus[1] == 0)
	{
		draw2board(posx,posy,zoom,ang);

		i = headsprite[1];
		while (i != -1)
		{
			sx = spritex[i]; sy = spritey[i];
			sx = ((sx-(posx-(1<<28)))&0x1fffffff)+(posx-(1<<28));
			sy = ((sy-(posy-(1<<28)))&0x1fffffff)+(posy-(1<<28));

			drawsprite(sx,sy,spritezoom[i],spriteang[i],spritepicnum[i],255);
			i = nextsprite[i];
		}

		showarrow();

		input2draw();

		readmouse();
		if (xdim < 640)
		{
			if (mousx > 0) mousx = ((mousx+1)>>1);
			if (mousx < 0) mousx >>= 1;
			if (mousy > 0) mousy = ((mousy+1)>>1);
			if (mousy < 0) mousy >>= 1;
		}
		searchx += mousx;
		searchy += mousy;
		if (searchx < 4) searchx = 4;
		if (searchy < 4) searchy = 4;
		if (searchx > xdim-5) searchx = xdim-5;
		if (searchy > ydim-5) searchy = ydim-5;
		for(i=1;i<=4;i++)
		{
			plotpixel(searchx+i,searchy,whitecol);
			plotpixel(searchx-i,searchy,whitecol);
			plotpixel(searchx,searchy+i,whitecol);
			plotpixel(searchx,searchy-i,whitecol);
		}

		cosang = mulscale((long)sintable[(ang+512)&2047],zoom,14);
		sinang = mulscale((long)sintable[ang],zoom,14);

		if ((bstatus&6) > 0)
		{
			x = searchx-(xdim>>1);
			y = searchy-(ydim>>1);
			posx += ((cosang*x - sinang*y)>>2);
			posy += ((sinang*x + cosang*y)>>2);
			//if (x < 0) searchx += ((3-x)>>2);
			//if (x > 0) searchx -= ((3+x)>>2);
			//if (y < 0) searchy += ((3-y)>>2);
			//if (y > 0) searchy -= ((3+y)>>2);
		}
		x = posx + (cosang*(searchx-pivotx)<<2) - (sinang*(searchy-pivoty)<<2);
		y = posy + (sinang*(searchx-pivotx)<<2) + (cosang*(searchy-pivoty)<<2);
		boardplc = (((x>>23)&63)<<6)+((y>>23)&63);

		if ((bstatus&1) > (obstatus&1))
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			searchspritestartx = x;
			searchspritestarty = y;
		}
		else if ((bstatus&1) < (obstatus&1))
		{
			if (searchsprite >= 0)
			{
				spritex[searchsprite] = ((spritex[searchsprite]+2097152)&0xffc00000);
				spritey[searchsprite] = ((spritey[searchsprite]+2097152)&0xffc00000);
				asksave = 1;
				searchsprite = -1;
			}
		}
		if ((bstatus&1) > 0)
		{
			if (searchsprite >= 0)
			{
				spritex[searchsprite] += x-searchspritestartx;
				spritey[searchsprite] += y-searchspritestarty;
				searchspritestartx = x;
				searchspritestarty = y;
				asksave = 1;
			}
		}
		if (keystatus[0xe] > 0)   //Backspace (strafe mode)
		{
			keystatus[0xe] = 0;
			strafemode ^= 1;
		}
		if (keystatus[0x3a] > 0)   //Caps lock (reset position)
		{
			keystatus[0x3a] = 0;
			zoom = 65536;
			ang = 0;
		}
		if (keystatus[0x46] > 0)   //Scroll lock (set starting position)
		{
			posx = ((posx+2097152)&0xffc00000);
			posy = ((posy+2097152)&0xffc00000);
			zoom = ((zoom+8192)&0xffffc000);
			ang = ((ang+64)&0x780);
			startposx = posx;
			startposy = posy;
			startzoom = zoom;
			startang = ang;
			asksave = 1;
			keystatus[0x46] = 0;
		}
		if (keystatus[0x33] > 0) // ,<
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
				spriteang[searchsprite] = ((spriteang[searchsprite]+(2048-128))&2047);
			asksave = 1;
			keystatus[0x33] = 0;
		}
		if (keystatus[0x34] > 0)  // .>
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
				spriteang[searchsprite] = ((spriteang[searchsprite]+(2048+128))&2047);
			asksave = 1;
			keystatus[0x34] = 0;
		}
		if (keystatus[0x37] > 0)  // Keypad *
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
				spritezoom[searchsprite] += (spritezoom[searchsprite]>>4);
			asksave = 1;
			keystatus[0x37] = 0;
		}
		if (keystatus[0xb5] > 0)  // Keypad /
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
				spritezoom[searchsprite] -= (spritezoom[searchsprite]>>4);
			asksave = 1;
			keystatus[0xb5] = 0;
		}

		if ((keystatus[0x21] > 0) && (somethingintab > 0)) // F
		{
			fillregion((x>>23)&63,(y>>23)&63,(short)temppicnum,(short)temppicnum);
			asksave = 1;
			keystatus[0x21] = 0;
		}
		if (((keystatus[0x2e]&keystatus[0x38]) > 0) && (somethingintab > 0)) // C
		{
			j = board2d[boardplc];
			for(i=0;i<4096;i++)
				if (board2d[i] == j)
					board2d[i] = temppicnum;
			asksave = 1;
			keystatus[0x2e] = 0;
		}
		if (keystatus[0x2f] > 0)  //V
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
			{
				spritepicnum[searchsprite] = (short)gettile((long)spritepicnum[searchsprite]);
			}
			else
			{
				templong = board2d[boardplc];
				templong = gettile(templong);
				board2d[boardplc] = templong;
			}
			asksave = 1;
			keystatus[0x2f] = 0;
		}
		if (keystatus[0x0f] > 0)  //TAB
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
			{
				temppicnum = spritepicnum[searchsprite];
				tempzoom = spritezoom[searchsprite];
				tempang = spriteang[searchsprite];
				somethingintab = 2;
			}
			else
			{
				temppicnum = board2d[boardplc];
				somethingintab = 1;
			}
			keystatus[0x0f] = 0;
		}
		if (((keystatus[0x39]|keystatus[0x1c]) > 0) && (somethingintab > 0))  //Space/L.Enter
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
			{
				if (somethingintab == 2)
				{
					spritezoom[searchsprite] = tempzoom;
					spriteang[searchsprite] = tempang;
				}
				spritepicnum[searchsprite] = temppicnum;
			}
			else
				board2d[boardplc] = temppicnum;
			asksave = 1;
		}
		if ((keystatus[0x1f]|keystatus[0xd2]) > 0)  //S,Insert (insert sprite)
		{
			i = insertsprite(1);
			spritex[i] = ((x+2097152)&0xffc00000);
			spritey[i] = ((y+2097152)&0xffc00000);
			spritezoom[i] = 65536;
			spriteang[i] = ((ang+64)&0x780);
			if (somethingintab > 0)
			{
				if (somethingintab == 2)
				{
					spritezoom[i] = tempzoom;
					spriteang[i] = tempang;
				}
				spritepicnum[i] = temppicnum;
			}
			else
				spritepicnum[i] = 0;

			keystatus[0x1f] = 0;
			keystatus[0xd2] = 0;
			asksave = 1;
		}
		if (keystatus[0xd3] > 0)  //Delete (delete sprite)
		{
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
			{
				deletesprite(searchsprite);
				searchsprite = -1;
			}
			keystatus[0xd3] = 0;
			asksave = 1;
		}
		if (keystatus[0xc9] > 0)       //PGUP
		{
			keystatus[0xc9] = 0;
			if (boardnum > 0)
			{
				if (asksave != 0)
				{
					asksave = 0;
					save2boardwithcheck();
				}
				boardnum--;
				load2board(boardfilename,boardnum,&startposx,&startposy,&startzoom,&startang);
				posx = startposx; posy = startposy; zoom = startzoom; ang = startang;

				sprintf(textmessage,"Map %d",boardnum);
				textmessagetime = totalclock+360;
			}
		}
		if (keystatus[0xd1] > 0)
		{
			keystatus[0xd1] = 0;
			if ((boardnum < MAXMAPS-1) && (boardnum < nummaps))
			{
				if (asksave != 0)
				{
					asksave = 0;
					save2boardwithcheck();
				}
				boardnum++;
				load2board(boardfilename,boardnum,&startposx,&startposy,&startzoom,&startang);
				posx = startposx; posy = startposy; zoom = startzoom; ang = startang;

				sprintf(textmessage,"Map %d",boardnum);
				textmessagetime = totalclock+360;
			}
		}
		if (keystatus[0x17])  //I (info)
		{
			keystatus[0x17] = 0;
			searchsprite = getspritenum(searchx<<16,searchy<<16);
			if (searchsprite >= 0)
				sprintf(textmessage,"Spr. %ld at (%ld,%ld) Sang:%ld Szoom:%ld",searchsprite,spritex[searchsprite]>>23,spritey[searchsprite]>>23,spriteang[searchsprite],spritezoom[searchsprite]);
			else
				sprintf(textmessage,"Tile %ld at (%ld,%ld)",board2d[boardplc],boardplc>>6,boardplc&63);
			textmessagetime = totalclock+360;

			//tile #, x,y tiles&pixels, zoom, angle
		}
		if ((keystatus[88]|keystatus[0x19]) > 0)   //F12
		{
			keystatus[0x19] = 0;
			keystatus[88] = 0;
			screencapture();
		}

		c = ((boardplc>>6)&63);
		d = (boardplc&63);
		if (keystatus[0x2] > 0)                    //1
		{
			keystatus[0x2] = 0;
			markx = c;
			marky = d;
		}
		if (keystatus[0x3] > 0)                    //2
		{
			keystatus[0x3] = 0;
			x = markx, y = marky, x2 = c, y2 = d;
			if (x > x2) templong = x, x = x2, x2 = templong;
			if (y > y2) templong = y, y = y2, y2 = templong;
			markxlen = x2-x+1;
			markylen = y2-y+1;
			for(i=0;i<markxlen;i++)
				for(j=0;j<markylen;j++)
					tempboard2d[(i<<6)+j] = board2d[((i+x)<<6)+(j+y)];
		}
		if (keystatus[0x4] > 0)                    //3
		{
			keystatus[0x4] = 0;
			for(i=0;i<markxlen;i++)
				for(j=0;j<markylen;j++)
					if ((i+c < 64) && (j+d < 64))
						board2d[((i+c)<<6)+(j+d)] = tempboard2d[(i<<6)+j];
			asksave = 1;
		}
		if (keystatus[0x5] > 0)                    //4
		{
			keystatus[0x5] = 0;
			for(i=0;i<(markxlen>>1);i++)
				for(j=0;j<markylen;j++)
				{
					templong = tempboard2d[(i<<6)+j];
					tempboard2d[(i<<6)+j] = tempboard2d[((markxlen-1-i)<<6)+j];
					tempboard2d[((markxlen-1-i)<<6)+j] = templong;
				}
		}
		if (keystatus[0x6] > 0)                    //5
		{
			keystatus[0x6] = 0;
			for(i=0;i<markxlen;i++)
				for(j=0;j<(markylen>>1);j++)
				{
					templong = tempboard2d[(i<<6)+j];
					tempboard2d[(i<<6)+j] = tempboard2d[(i<<6)+(markylen-1-j)];
					tempboard2d[(i<<6)+(markylen-1-j)] = templong;
				}
		}
		if (keystatus[0x7] > 0)                    //6
		{
			keystatus[0x7] = 0;
			for(i=0;i<64;i++)
				for(j=0;j<64;j++)
					if (i > j)
					{
						templong = tempboard2d[(j<<6)+i];
						tempboard2d[(j<<6)+i] = tempboard2d[(i<<6)+j];
						tempboard2d[(i<<6)+j] = templong;
					}
			templong = markxlen;
			markxlen = markylen;
			markylen = templong;
		}

		if (totalclock < textmessagetime)
			printext256(xdim-(strlen(textmessage)<<3),0L,31,0,textmessage,0);

		i = totalclock; j = (numframes&(AVERAGEFRAMES-1));
		if (i != frameval[j])
		{
			if (numframes >= AVERAGEFRAMES)
			{
				k = divmod((AVERAGEFRAMES*1200)/(i-frameval[j]),10);
				sprintf(tempbuf,"%ld.%ld",k,dmval);
				printext256(0L,0L,31L,-1L,tempbuf,1);
			}
			frameval[j] = i;
		}

		numframes++;
		nextpage();
	}
	if (asksave != 0)
	{
		asksave = 0;
		save2boardwithcheck();
	}
	if (needtosavepicanm != 0)
		savepicanms();

	uninittimer();
	uninit2draw();
	printf("2DRAW programmed by Ken Silverman\n");
}

showarrow()
{
	long t, x, y, xv, yv, dax, day, cosang, sinang;

	cosang = divscale((long)sintable[(ang+512)&2047],zoom,18);
	sinang = divscale((long)sintable[ang],zoom,18);

	x = (pivotx<<8) - mulscale(posx-startposx,cosang,26) - mulscale(posy-startposy,sinang,26);
	y = (pivoty<<8) - mulscale(posy-startposy,cosang,26) + mulscale(posx-startposx,sinang,26);

	if (((x>>8) >= 0) && ((y>>8) >= 0) && ((x>>8) < xdim) && ((y>>8) < ydim))
	{
		xv = divscale((long)sintable[((startang+2048-ang)+512)&2047],zoom,14);
		yv = divscale((long)sintable[(startang+2048-ang)&2047],zoom,14);

		for(t=0;t<32;t++)
		{
			dax = x+mulscale(yv,t-16,5);
			day = y+mulscale(-xv,t-16,5);
			if ((dax > 0) && (day > 0) && ((dax>>8) < xdim) && ((day>>8) < ydim))
				plotpixel(dax>>8,day>>8,0);

			dax = x+mulscale(xv-yv,t,6)+(yv>>1);
			day = y+mulscale(yv+xv,t,6)-(xv>>1);
			if ((dax > 0) && (day > 0) && ((dax>>8) < xdim) && ((day>>8) < ydim))
				plotpixel(dax>>8,day>>8,0);

			dax = x+mulscale(-xv-yv,t,6)+(yv>>1);
			day = y+mulscale(-yv+xv,t,6)-(xv>>1);
			if ((dax > 0) && (day > 0) && ((dax>>8) < xdim) && ((day>>8) < ydim))
				plotpixel(dax>>8,day>>8,0);
		}
	}
}

gettile(long tilenum)
{
	char snotbuf[80];
	long i, j, k, otilenum, topleft, gap, temp, templong;
	long xtiles, ytiles, tottiles;

	otilenum = tilenum;

	keystatus[0x2f] = 0;

	localartlookupnum = MAXTILES;
	for(i=0;i<MAXTILES;i++)
		localartlookup[i] = i;

	xtiles = (xdim>>6); ytiles = (ydim>>6); tottiles = xtiles*ytiles;

	topleft = ((tilenum/(xtiles<<gettilezoom))*(xtiles<<gettilezoom))-(xtiles<<gettilezoom);
	if (topleft < 0) topleft = 0;
	if (topleft > MAXTILES-(tottiles<<(gettilezoom<<1))) topleft = MAXTILES-(tottiles<<(gettilezoom<<1));
	while ((keystatus[0x1c]|keystatus[1]) == 0)
	{
		drawtilescreen(topleft,tilenum);

		if (tilenum < localartlookupnum)         //Print clip bits on bottom
		{
			i = localartlookup[tilenum];
			printclipbits((char)(picanm[i]>>24));
			if (keystatus[0x3b] > 0) picanm[i] ^= 0x80000000, keystatus[0x3b] = 0, needtosavepicanm = 1;
			if (keystatus[0x3c] > 0) picanm[i] ^= 0x40000000, keystatus[0x3c] = 0, needtosavepicanm = 1;
			if (keystatus[0x3d] > 0) picanm[i] ^= 0x20000000, keystatus[0x3d] = 0, needtosavepicanm = 1;
			if (keystatus[0x3e] > 0) picanm[i] ^= 0x10000000, keystatus[0x3e] = 0, needtosavepicanm = 1;
			if (keystatus[0x3f] > 0) picanm[i] ^= 0x08000000, keystatus[0x3f] = 0, needtosavepicanm = 1;
			if (keystatus[0x40] > 0) picanm[i] ^= 0x04000000, keystatus[0x40] = 0, needtosavepicanm = 1;
			if (keystatus[0x41] > 0) picanm[i] ^= 0x02000000, keystatus[0x41] = 0, needtosavepicanm = 1;
			if (keystatus[0x42] > 0) picanm[i] ^= 0x01000000, keystatus[0x42] = 0, needtosavepicanm = 1;
		}

		nextpage();
		if (option[0] != 2) limitrate();

		if ((keystatus[0x37] > 0) && (gettilezoom < 2))
		{
			gettilezoom++;
			topleft = ((tilenum/(xtiles<<gettilezoom))*(xtiles<<gettilezoom))-(xtiles<<gettilezoom);
			if (topleft < 0) topleft = 0;
			if (topleft > MAXTILES-(tottiles<<(gettilezoom<<1))) topleft = MAXTILES-(tottiles<<(gettilezoom<<1));
			keystatus[0x37] = 0;
		}
		if ((keystatus[0xb5] > 0) && (gettilezoom > 0))
		{
			gettilezoom--;
			topleft = ((tilenum/(xtiles<<gettilezoom))*(xtiles<<gettilezoom))-(xtiles<<gettilezoom);
			if (topleft < 0) topleft = 0;
			if (topleft > MAXTILES-(tottiles<<(gettilezoom<<1))) topleft = MAXTILES-(tottiles<<(gettilezoom<<1));
			keystatus[0xb5] = 0;
		}
		if ((keystatus[0xcb] > 0) && (tilenum > 0))
			tilenum--, keystatus[0xcb] = 0;
		if ((keystatus[0xcd] > 0) && (tilenum < MAXTILES-1))
			tilenum++, keystatus[0xcd] = 0;
		if ((keystatus[0xc8] > 0) && (tilenum >= (xtiles<<gettilezoom)))
			tilenum-=(xtiles<<gettilezoom), keystatus[0xc8] = 0;
		if ((keystatus[0xd0] > 0) && (tilenum < MAXTILES-(xtiles<<gettilezoom)))
			tilenum+=(xtiles<<gettilezoom), keystatus[0xd0] = 0;
		if ((keystatus[0xc9] > 0) && (tilenum >= (xtiles<<gettilezoom)))
		{
			tilenum-=(tottiles<<(gettilezoom<<1));
			if (tilenum < 0) tilenum = 0;
			keystatus[0xc9] = 0;
		}
		if ((keystatus[0xd1] > 0) && (tilenum < MAXTILES-(xtiles<<gettilezoom)))
		{
			tilenum+=(tottiles<<(gettilezoom<<1));
			if (tilenum >= MAXTILES) tilenum = MAXTILES;
			keystatus[0xd1] = 0;
		}
		if (keystatus[0x22] > 0)       //G (goto)
		{
			if (tilenum < localartlookupnum)         //Automatically press 'V'
				tilenum = localartlookup[tilenum];
			else
				tilenum = 0;
			localartlookupnum = MAXTILES;
			for(i=0;i<MAXTILES;i++)
				localartlookup[i] = i;

			keystatus[0x22] = 0;

			j = tilenum;
			while (keystatus[1] == 0)
			{
				drawtilescreen(topleft,tilenum);
				if (option[0] != 2) limitrate();
				sprintf(&snotbuf,"Goto tile: %d_ ",j);
				printext256(0,0,whitecol,0,snotbuf,0,0);
				nextpage();

				for(k=0;k<10;k++)
					if (keystatus[((k+9)%10)+2] > 0)
					{
						keystatus[((k+9)%10)+2] = 0;
						i = (j*10)+k;
						if (i < 4096) j = i;
					}
				if (keystatus[0xe] > 0)
				{
					keystatus[0xe] = 0;
					j /= 10;
				}
				if (keystatus[0x1c] > 0)
				{
					keystatus[0x1c] = 0;
					tilenum = j;
					break;
				}
			}
		}
		while (tilenum < topleft) topleft -= (xtiles<<gettilezoom);
		while (tilenum >= topleft+(tottiles<<(gettilezoom<<1))) topleft += (xtiles<<gettilezoom);
	}

	if (keystatus[0x1c] == 0)
	{
		tilenum = otilenum;
	}
	else
	{
		if (tilenum < localartlookupnum)
		{
			tilenum = localartlookup[tilenum];
			if ((tilesizx[tilenum] == 0) || (tilesizy[tilenum] == 0))
				tilenum = otilenum;
		}
		else
			tilenum = otilenum;
	}
	keystatus[0x1] = 0;
	keystatus[0x1c] = 0;
	return(tilenum);
}

drawtilescreen(long pictopleft, long picbox)
{
	long i, j, vidpos, vidpos2, dat, wallnum, xdime, ydime, cnt, pinc;
	long dax, day, scaledown, xtiles, ytiles, tottiles;
	char *picptr;

	clearscreen(0);
	xtiles = (xdim>>6); ytiles = (ydim>>6); tottiles = xtiles*ytiles;
	pinc = ylookup[1];
	for(cnt=0;cnt<(tottiles<<(gettilezoom<<1));cnt++)         //draw the 5*3 grid of tiles
	{
		wallnum = cnt+pictopleft;
		if (wallnum < localartlookupnum)
		{
			wallnum = localartlookup[wallnum];
			if ((tilesizx[wallnum] != 0) && (tilesizy[wallnum] != 0))
			{
				if (waloff[wallnum] == 0) loadtile(wallnum);
				xdime = tilesizx[wallnum];
				ydime = tilesizy[wallnum];

				dax = ((cnt%(xtiles<<gettilezoom))<<(6-gettilezoom));
				day = ((cnt/(xtiles<<gettilezoom))<<(6-gettilezoom));
				if (chainstat)
					vidpos = ylookup[day]+(dax>>2)+chainplace;
				else
					vidpos = ylookup[day]+dax+frameplace;
				if ((xdime <= (64>>gettilezoom)) && (ydime <= (64>>gettilezoom)))
				{
					for(i=0;i<xdime;i++)
					{
						if (chainstat)
						{
							outpw(0x3c4,2+(256<<(i&3)));
							vidpos2 = vidpos+(i>>2);
						}
						else
							vidpos2 = vidpos+i;
						picptr = (char *)(waloff[wallnum]) + (i<<8);
						for(j=0;j<ydime;j++)
						{
							dat = *picptr++;
							drawpixel(vidpos2, dat);
							vidpos2 += pinc;
						}
					}
				}
				else                          //if 1 dimension > 64
				{
					if (xdime > ydime)
						scaledown = ((xdime+(63>>gettilezoom))>>(6-gettilezoom));
					else
						scaledown = ((ydime+(63>>gettilezoom))>>(6-gettilezoom));

					dax = 0;
					for(i=0;i<xdime;i+=scaledown)
					{
						if (waloff[wallnum] == 0) loadtile(wallnum);
						picptr = (char *)(waloff[wallnum]) + (i<<8);
						if (chainstat)
							outpw(0x3c4,2+(256<<(dax&3)));
						vidpos2 = vidpos;
						for(j=0;j<ydime;j+=scaledown)
						{
							dat = *picptr;
							picptr += scaledown;
							drawpixel(vidpos2, dat);
							vidpos2 += pinc;
						}
						dax++;
						if ((!chainstat) || ((dax&3) == 0))
							vidpos++;
					}
				}
			}
		}
	}

	cnt = picbox-pictopleft;    //draw open white box
	dax = ((cnt%(xtiles<<gettilezoom))<<(6-gettilezoom));
	day = ((cnt/(xtiles<<gettilezoom))<<(6-gettilezoom));

	for(i=0;i<(64>>gettilezoom);i++)
	{
		plotpixel(dax+i,day,whitecol);
		plotpixel(dax+i,day+(63>>gettilezoom),whitecol);
		plotpixel(dax,day+i,whitecol);
		plotpixel(dax+(63>>gettilezoom),day+i,whitecol);
	}

	return(0);
}

printclipbits(char clipbits)
{
	long i, j, k, b, vidpos;

	for(k=0;k<8;k++)
	{
		b = ((clipbits>>(7-k))&1);

		if (chainstat)
		{
			outp(0x3c4,2);
			vidpos = ylookup[ydim-8]+(k<<1)+chainplace;
			if (b == 0)
			{
				outp(0x3c5,12);
				drawpixel(vidpos,31);
				drawpixel(vidpos+ylookup[7],31);
				outp(0x3c5,3);
				drawpixel(vidpos+1,31);
				drawpixel(vidpos+ylookup[7]+1,31);
				outp(0x3c5,2);
				for(i=1;i<7;i++) drawpixel(vidpos+ylookup[i],31);
				outp(0x3c5,4);
				for(i=1;i<7;i++) drawpixel(vidpos+ylookup[i]+1,31);
			}
			else
			{
				outp(0x3c5,8);
				for(i=0;i<8;i++) drawpixel(vidpos+ylookup[i],31);
			}
		}
		else
		{
			vidpos = ylookup[ydim-8]+(k<<3)+frameplace;
			if (b == 0)
			{
				for(i=2;i<6;i++)
				{
					drawpixel(vidpos+i,31);
					drawpixel(vidpos+ylookup[7]+i,31);
				}
				for(i=1;i<7;i++)
				{
					drawpixel(vidpos+ylookup[i]+1,31);
					drawpixel(vidpos+ylookup[i]+6,31);
				}
			}
			else
			{
				for(i=0;i<8;i++) drawpixel(vidpos+ylookup[i]+3,31);
			}
		}
	}
}

fillregion(long x, long y, short col, short bound)
{
	short tstat, bstat, tlast, blast;
	short i, leftz, z, zz, c;

	c = 1;
	xfillbuf[c] = x;
	yfillbuf[c] = y;
	if (board2d[(x<<6)+y] == bound)
		return(-1);
	while (c > 0)
	{
		z = xfillbuf[c];
		zz = yfillbuf[c];
		c--;
		while ((board2d[((z-1)<<6)+zz] != bound) && (z > 0))
			z--;
		leftz = z;
		tlast = 0;
		blast = 0;
		while ((board2d[(z<<6)+zz] != bound) && (z < 64))
		{
			if (zz > 0)
			{
				tstat = board2d[(z<<6)+zz-1];
				if ((tstat != bound) && (tstat != col))
				{
					if (tlast == 0)
					{
						c++;
						xfillbuf[c] = z;
						yfillbuf[c] = zz-1;
						tlast = 1;
					}
				}
				else
					tlast = 0;
			}
			if (zz < 64-1)
			{
				bstat = board2d[(z<<6)+zz+1];
				if ((bstat != bound) && (bstat != col))
				{
					if (blast == 0)
					{
						c++;
						xfillbuf[c] = z;
						yfillbuf[c] = zz+1;
						blast = 1;
					}
				}
				else
					blast = 0;
			}
			z++;
		}
		z--;
		while (z >= leftz)
		{
			if ((z >= 0) && (z < 64))
				board2d[(z<<6)+zz] = col;
			z--;
		}
	}
	return(0);
}

input2draw()
{
	short i, j, movez, numtics;

	numtics = (short int)totalclock-lockclock;
	if (numtics == 0) return;
	lockclock += numtics;

	mousx = 0;
	mousy = 0;
	mstrafe = 0;

	if (keystatus[keys[5]] != strafemode)
	{
		if (keystatus[keys[2]] > 0) mstrafe -= (numtics<<(4+keystatus[keys[4]]));
		if (keystatus[keys[3]] > 0) mstrafe += (numtics<<(4+keystatus[keys[4]]));
	}
	else
	{
		if (keystatus[keys[2]] > 0) mousx -= (numtics<<2);
		if (keystatus[keys[3]] > 0) mousx += (numtics<<2);
	}
	if (keystatus[keys[0]] > 0) mousy -= (numtics<<(4+keystatus[keys[4]]));
	if (keystatus[keys[1]] > 0) mousy += (numtics<<(4+keystatus[keys[4]]));
	i = angvel;
	angvel = (((angvel<<2)+(angvel<<1)+angvel+mousx)>>3);
	if (i == angvel)
	{
		if (mousx < angvel) angvel--;
		if (mousx > angvel) angvel++;
	}
	i = vel;
	vel = (((vel<<2)+(vel<<1)+vel+mousy)>>3);
	if (i == vel)
	{
		if (mousy < vel) vel--;
		if (mousy > vel) vel++;
	}
	i = svel;
	svel = (((svel<<2)+(svel<<1)+svel+mstrafe)>>3);
	if (i == svel)
	{
		if (mstrafe < svel) svel--;
		if (mstrafe > svel) svel++;
	}

	ang = (ang+2048+angvel)&2047;
	if (vel != 0)
	{
		posx += (((long)sintable[(2048-ang)&2047])*((long)vel));
		posy += (((long)sintable[(2560-ang)&2047])*((long)vel));
	}
	if (svel != 0)
	{
		posx += (((long)sintable[(2560-ang)&2047])*((long)svel));
		posy += (((long)sintable[(1024-ang)&2047])*((long)svel));
	}

	movez = 0;
	if (keystatus[keys[8]] > 0) movez -= (((long)numtics)<<(7+(keystatus[keys[4]]<<1)));
	if (keystatus[keys[9]] > 0) movez += (((long)numtics)<<(7+(keystatus[keys[4]]<<1)));

	i = zoomvel;
	zoomvel = (((zoomvel<<2)+(zoomvel<<1)+zoomvel+movez)>>3);
	if (i == zoomvel)
	{
		if (movez < zoomvel) zoomvel--;
		if (movez > zoomvel) zoomvel++;
	}
	zoom += zoomvel;
	if (zoom < 16384) zoom = 16384;
	if (zoom > 1048576) zoom = 1048576;
}

getspritenum(long dasearchx, long dasearchy)
{
	short rela, bad, findsprite;
	long i, j, xdime, ydime, cosang, sinang, cx, cy, relz, dist, xinc, yinc;
	long x1, y1, x2, y2, x3, y3, x4, y4;

	findsprite = -1;
	for(i=0;i<MAXSTATUS;i++)
	{
		j = headsprite[i];
		while (j >= 0)
		{
			xdime = tilesizx[spritepicnum[j]];
			ydime = tilesizy[spritepicnum[j]];

			cosang = divscale((long)sintable[(ang+2560)&2047],zoom,14);
			sinang = divscale((long)sintable[(ang+2048)&2047],zoom,14);

			cx = (pivotx<<16)+mulscale(cosang,spritex[j]-posx,14)+mulscale(sinang,spritey[j]-posy,14);
			cy = (pivoty<<16)+mulscale(cosang,spritey[j]-posy,14)-mulscale(sinang,spritex[j]-posx,14);

			relz = divscale(spritezoom[j],zoom,16);
			dist = ((relz*(xdime+ydime))>>1);
			bad = 0;
			if ((cx+dist < 0L) || (cy+dist < 0L)) bad = 1;
			if ((cx-dist > (xdim<<16)) || (cy-dist > (ydim<<16))) bad = 1;
			if ((relz == 0) || (xdime <= 0) || (ydime <= 0)) bad = 1;

			if (bad == 0)
			{
				rela = ((spriteang[j]+2048-ang)&2047);
				cosang = sintable[(rela+2560)&2047];
				sinang = sintable[(rela+2048)&2047];
				xinc = divscale(cosang,relz,18);
				yinc = divscale(sinang,relz,18);
				cosang = mulscale(cosang,relz,16);
				sinang = mulscale(sinang,relz,16);

				x1 = cx - ((cosang*(xdime) - sinang*(ydime))<<1);
				y1 = cy - ((sinang*(xdime) + cosang*(ydime))<<1);
				x2 = cx - ((cosang*(-xdime) - sinang*(ydime))<<1);
				y2 = cy - ((sinang*(-xdime) + cosang*(ydime))<<1);
				x3 = cx + ((cosang*(xdime) - sinang*(ydime))<<1);
				y3 = cy + ((sinang*(xdime) + cosang*(ydime))<<1);
				x4 = cx + ((cosang*(-xdime) - sinang*(ydime))<<1);
				y4 = cy + ((sinang*(-xdime) + cosang*(ydime))<<1);

				if (mulscale(x2-x1,dasearchy-y1,20) >= mulscale(dasearchx-x1,y2-y1,20))
					if (mulscale(x3-x2,dasearchy-y2,20) >= mulscale(dasearchx-x2,y3-y2,20))
						if (mulscale(x4-x3,dasearchy-y3,20) >= mulscale(dasearchx-x3,y4-y3,20))
							if (mulscale(x1-x4,dasearchy-y4,20) >= mulscale(dasearchx-x4,y1-y4,20))
								findsprite = j;

			}
			j = nextsprite[j];
		}
	}
	return(findsprite);
}

save2boardwithcheck()
{
	keystatus[0x15] = 0;

	printext256(0L,0L,31,-1,"Save changes?",0);
	nextpage();

	while (keystatus[0x31] == 0)
	{
		if (keystatus[0x15] > 0)         //Y
		{
			keystatus[0x15] = 0;
			save2board(boardfilename,boardnum,startposx,startposy,startzoom,startang);
			return;
		}
	}
	keystatus[0x31] = 0;
	keystatus[0x15] = 0;
}

inittimer()
{
	outp(0x43,0x34); outp(0x40,9942&255); outp(0x40,9942>>8);  //120 times/sec
	oldtimerhandler = _dos_getvect(0x8);
	_disable(); _dos_setvect(0x8, timerhandler); _enable();
}

uninittimer()
{
	outp(0x43,0x34); outp(0x40,0); outp(0x40,0);           //18.2 times/sec
	_disable(); _dos_setvect(0x8, oldtimerhandler); _enable();
}

void __interrupt __far timerhandler()
{
	totalclock++;
	outp(0x20,0x20);
}

faketimerhandler()
{
}
