#define ENGINE
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <i86.h>
#include "2draw.h"
#include "pragmas.h"

#define MAXCLIPNUM 256

#pragma aux setvesamode =\
	"int 0x10",\
	parm [eax][ebx]\

char vidoption, chainstat = 0;
long chainplace, chainsiz, chainnumpages = 0;  //Vidoption 0 only
long page;                                     //Vidoption 3-6 only

static short capturecount;
static char pcxheader[128] =
{
	0xa,0x5,0x1,0x8,0x0,0x0,0x0,0x0,0x3f,0x1,0xc7,0x0,
	0x40,0x1,0xc8,0x0,0x0,0x0,0x0,0x8,0x8,0x8,0x10,0x10,
	0x10,0x18,0x18,0x18,0x20,0x20,0x20,0x28,0x28,0x28,0x30,0x30,
	0x30,0x38,0x38,0x38,0x40,0x40,0x40,0x48,0x48,0x48,0x50,0x50,
	0x50,0x58,0x58,0x58,0x60,0x60,0x60,0x68,0x68,0x68,0x70,0x70,
	0x70,0x78,0x78,0x78,0x0,0x1,0x40,0x1,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
};

char picsiz[MAXTILES], *pic, tilefilenum[MAXTILES];
static long tilefileoffs[MAXTILES];
long artversion, numtiles;
static char artfilename[20];
static long localtilestart[MAXTILEFILES], localtileend[MAXTILEFILES];
static long numtilefiles, picsloaded = 0;
static long artfil = -1, artfilnum, artfilplc;

static char tempbuf[4096];
static short tempshort[MAXTILES];
static long ylookup[MAXYDIM];

static long artsize = 0;

long asm1, asm2, asm3, asm4;

long mapversion, curboardbytes;
short numsprites[MAXMAPS];

char editstatus = 0;

long numframes, totalclock, frameplace;

short radarang[1280];
char textfont[1024], smalltextfont[1024];

static long globalposx, globalposy, globalzoom;
static short globalang;
static long globalcosang, globalsinang;

static long px[8], py[8], npx[8], npy[8];
static long clipx[2], clipy[2], clipxlo[2], clipylo[2], clipxxor, clipyxor;
static short topy[MAXXDIM], boty[MAXXDIM];

static short clipnum;
static long clipx1[MAXCLIPNUM], clipy1[MAXCLIPNUM];
static long clipx2[MAXCLIPNUM], clipy2[MAXCLIPNUM];

volatile char readch, oldreadch, extended, keytemp;

void (__interrupt __far *oldkeyhandler)();
void __interrupt __far keyhandler(void);

#include "ves2.h"

extern void setupdrawbpl(long);
#pragma aux setupdrawbpl parm [eax];
extern void setupdrawbackmach(long,long,long,long,long,long);
#pragma aux setupdrawbackmach parm [eax][ebx][ecx][edx][esi][edi];
extern void drawback(long,long,long,long,long,long);
#pragma aux drawback parm [eax][ebx][ecx][edx][esi][edi];
extern void setupdrawspritemach(long,long,long);
#pragma aux setupdrawspritemach parm [eax][ebx][ecx];
extern void setupsolidspritemach(long);
#pragma aux setupsolidspritemach parm [eax];
extern void drawspritevline1(long,long,long,long,long,long);
#pragma aux drawspritevline1 parm [eax][ebx][ecx][edx][esi][edi];
extern void drawspritevline2(long,long,long,long,long,long);
#pragma aux drawspritevline2 parm [eax][ebx][ecx][edx][esi][edi];

void __interrupt __far keyhandler()
{
	oldreadch = readch; readch = kinp(0x60);
	keytemp = kinp(0x61); koutp(0x61,keytemp|128); koutp(0x61,keytemp&127);
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
			keystatus[(readch&127)+extended] = ((readch>>7)^1);
		extended = 0;
	}
	koutp(0x20,0x20);
}

init2draw(char davidoption, long daxdim, long daydim)
{
	long i, j;

	vidoption = davidoption; xdim = daxdim; ydim = daydim;
	pivotx = (xdim>>1); pivoty = (ydim>>1);
	setview(0L,0L,xdim-1,ydim-1);

	randomseed = readtimer();
	loadtables();

	numframes = 0L;
	for(i=0;i<256;i++) keystatus[i] = 0;
	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();

	chainnumpages = 0;
	chainstat = 0;
	switch(vidoption)
	{
		case 0:
			setvmode(0x13);
			if (setxmode(xdim,ydim) < 0)
			{
				setvmode(0x3);
				printf("%ld * %ld chained mode not supported\n",xdim,ydim);
				exit(0);
			}
			koutpw(0x3c4,0x0f02);
			clearbuf(0xa0000,(65536L>>2),0L);

			chainplace = 0xa0000;
			chainsiz = ((((xdim*ydim)>>2)+255)&0xffffff00);
			chainnumpages = 65536/chainsiz;

			if (chainnumpages == 1)
			{
				screen = (char *)malloc(xdim*ydim);
				frameplace = FP_OFF(screen);
				clearbuf(frameplace,(xdim*ydim)>>2,0L);
			}
			if (chainnumpages >= 2)
			{
				chainstat = 1;
				bytesperline = (xdim>>2);
			}
			else
				bytesperline = xdim;
			break;
		case 1:
			setvesa(xdim,ydim,8);
			for(i=0;i<maxpages;i++)
			{
				setactivepage(i);
				clearbufbyte(frameplace,imageSize,0L);
			}
			break;
		case 2:
			xdim = 320; ydim = 200; imageSize = 64000; bytesperline = 320;
			screen = (char *)malloc(xdim*ydim);
			frameplace = FP_OFF(screen);
			setvmode(0x13);
			clearbuf(frameplace,(xdim*ydim)>>2,0L);
			break;
		case 3:
			xdim = 320; ydim = 200; imageSize = 64000; bytesperline = 320;
			setvmode(0x13);
			frameplace = 0xa0000;

			for(i=0;i<4;i++)
				{ koutp(0x3cd,i), clearbuf(0xa0000,16000L,0L); }

			page = 0; koutp(0x3cd,page+(page<<4));
			break;
		case 4:
			xdim = 320; ydim = 200; imageSize = 64000; bytesperline = 320;
			setvmode(0x13);
			frameplace = 0xa0000;
			koutpw(0x3ce,0x050f);
			koutpw(0x3d4,0x8529);
			koutpw(0x3c4,0x4806);
			koutpw(0x3d4,0x002f);   //set mod = 256k

			for(i=0;i<4;i++)
				{ koutpw(0x3ce,0x09+(i<<12)); clearbuf(0xa0000,16000L,0L); }

			page = 0; koutpw(0x3ce,0x9+(page<<12));
			break;
		case 5:
			xdim = 320; ydim = 200; imageSize = 64000; bytesperline = 320;
			setvmode(0x13);
			frameplace = 0xa0000;
			koutpw(0x3d4,0x4838);           //S3 Extensions enable #1
			koutpw(0x3d4,0xa539);           //S3 Extensions enable #2
			koutp(0x3d4,0x31); koutp(0x3d5,kinp(0x3d5)|9);   //Init for start address

			for(i=0;i<4;i++)
				{ koutpw(0x3d4,0x35+(i<<8)); clearbuf(0xa0000,16000L,0L); }

			page = 0; koutpw(0x3d4,0x35+(page<<8));
			break;
		case 6:
			xdim = 320; ydim = 200; imageSize = 64000; bytesperline = 320;
			frameplace = 0xa0000;

			setvesamode(0x4f02,0x100);
			koutp(0x3c8,128); for(i=0;i<384;i++) koutp(0x3c9,i/6);
			koutpw(0x3c4,0x0604);  //Chain mode
			koutpw(0x3c4,0x0787);  //Set 1280 / draw every other pixel mode
			koutpw(0x3d4,0x4109);  //Set from ?*400 to ?*200 mode
			koutpw(0x3d4,0xa013);  //Bytesperline = 160

			for(i=0;i<4;i++)
				{ koutpw(0x3ce,0x09+(i<<10)); clearbuf(0xa0000,16000L,0L); }

			page = 0; koutpw(0x3ce,0x09+(page<<10));
			break;
	}

	numpages = 1;
	if (chainstat) numpages = chainnumpages;
	if (vidoption == 1) numpages = min(maxpages,8);
	if (vidoption >= 3) numpages = 4;

	j = 0;
	setupdrawbpl(bytesperline);
	for(i=0;i<MAXYDIM;i++) { ylookup[i] = j; j += bytesperline; }
}

uninit2draw()
{
	long templong;

	_disable(); _dos_setvect(0x9, oldkeyhandler); _enable();

	if (vidoption == 1) uninitvesa();
	if (screen != NULL) { free(screen); screen = NULL; }

	setvmode(0x3);
	unloadpics();
}

nextpage()
{
	long i, j, k, totbytes;

	switch(vidoption)
	{
		case 0:
			if (chainstat)
			{
				koutpw(0x3d4,0xc+(chainplace&0xff00));
				chainplace += chainsiz;
				if (chainplace+chainsiz >= 0xb0000) chainplace = 0xa0000;
				if (chainnumpages == 2)
				{
					limitrate();
					faketimerhandler();
				}
			}
			else
			{
				koutp(0x3c4,2); j = frameplace; k = 0xa0000;
				for(i=0;i<ydim;i+=2)
				{
					koutp(0x3c5,1); chainblit(j,k,xdim>>3);
					koutp(0x3c5,2); chainblit(j+1,k,xdim>>3);
					koutp(0x3c5,4); chainblit(j+2,k,xdim>>3);
					koutp(0x3c5,8); chainblit(j+3,k,xdim>>3);
					j += (xdim<<1); k += (xdim>>1);
					faketimerhandler();
				}
			}
			break;
		case 1:
			setvisualpage(page);
			page++; if (page >= numpages) page = 0;
			setactivepage(page);
			break;
		case 2:
			copybuf(frameplace,0xa0000,16000L);
			faketimerhandler();
			break;
		case 3:
			koutpw(0x3d4,0xc+(page<<14));
			page = ((page+1)&3);
			koutp(0x3cd,page+(page<<4));
			break;
		case 4:
			koutpw(0x3d4,0xc+(page<<14));
			page = ((page+1)&3);
			koutpw(0x3ce,0x9+(page<<12));
			break;
		case 5:
			koutpw(0x3d4,0xc+(page<<14));
			page = ((page+1)&3);
			koutpw(0x3d4,0x35+(page<<8));
			break;
		case 6:
			koutpw(0x3d4,0x1b+((page&1)<<8)+((page|1)<<9));
			page = ((page+1)&3);
			koutpw(0x3ce,0x09+(page<<10));
			break;
	}

	numframes++;
}

loadtables()
{
	long i, fil;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) == -1)
	{
		printf("I need Tables.dat!");
		exit(0);
	}
	read(fil,sintable,4096);
	read(fil,radarang,640*2);
	for(i=0;i<640;i++) radarang[1279-i] = -radarang[i];
	read(fil,textfont,1024);
	read(fil,smalltextfont,1024);
	close(fil);
}

loadtile (short tnum)
{
	char *ptr;
	long i, j, k, l, xsiz, ysiz;

	if ((tilesizx[tnum] <= 0) || (tilesizy[tnum] <= 0)) return;

	i = tilefilenum[tnum];
	if (i != artfilnum)
	{
		if (artfil != -1) close(artfil);
		artfilnum = i;
		artfilplc = 0L;

		artfilename[7] = (i%10)+48;
		artfilename[6] = ((i/10)%10)+48;
		artfilename[5] = ((i/100)%10)+48;
		artfil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD);
	}

	xsiz = tilesizx[tnum];
	ysiz = tilesizy[tnum]; if (ysiz > 256) ysiz = 256;

	if (waloff[tnum] == 0) cachebox((long)&waloff[tnum],xsiz,ysiz);

	if (artfilplc != tilefileoffs[tnum])
	{
		artfilplc = tilefileoffs[tnum];
		lseek(artfil,artfilplc,SEEK_SET);
	}
	ptr = (char *)waloff[tnum];

	l = 16;
	if (ysiz <= 128)
	{
		l = 32;
		if (ysiz <= 64)
		{
			l = 64;
			if (ysiz <= 64) l = 128;
		}
	}
	for(i=0;i<xsiz;i+=l)
	{
		j = min(xsiz-i,l);
		read(artfil,tempbuf,j*ysiz);

		k = FP_OFF(tempbuf);
		while (j > 0)
		{
			copybufbyte(k,ptr,ysiz);
			j--; k += ysiz; ptr += 256;
		}
	}
	artfilplc += xsiz*ysiz;
}

loadpics(char *filename)
{
	long i, j, k, fil, offscount, siz, templongbuf[4];

	strcpy(artfilename,filename);

	for(i=0;i<MAXTILES;i++)
		{ waloff[i] = 0; tilesizx[i] = 0L; tilesizy[i] = 0L; picanm[i] = 0L; }

	artsize = 0L;

	numtilefiles = 0;
	do
	{
		k = numtilefiles;

		artfilename[7] = (k%10)+48;
		artfilename[6] = ((k/10)%10)+48;
		artfilename[5] = ((k/100)%10)+48;
		if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
		{
			read(fil,templongbuf,16);
			artversion = templongbuf[0]; if (artversion != 1) return(-1);
			numtiles = templongbuf[1];
			localtilestart[k] = templongbuf[2];
			localtileend[k] = templongbuf[3];
			read(fil,tempshort,(localtileend[k]-localtilestart[k]+1)<<1);
			for(i=localtileend[k]-localtilestart[k];i>=0;i--)
				tilesizx[i+localtilestart[k]] = tempshort[i];
			read(fil,tempshort,(localtileend[k]-localtilestart[k]+1)<<1);
			for(i=localtileend[k]-localtilestart[k];i>=0;i--)
				tilesizy[i+localtilestart[k]] = tempshort[i];
			read(fil,&picanm[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<2);

			offscount = 4+4+4+4+((localtileend[k]-localtilestart[k]+1)<<3);
			for(i=localtilestart[k];i<=localtileend[k];i++)
			{
				tilefilenum[i] = k;
				tilefileoffs[i] = offscount;
				j = tilesizx[i]*tilesizy[i];
				offscount += j; artsize += j;
			}
			close(fil);

			numtilefiles++;
		}
	}
	while (k != numtilefiles);

		//150% of art size
	i = ((artsize+(artsize>>1)+65536)&0xffffff00);
	while ((pic = (char *)malloc(i)) == NULL) i -= 65536;
	initcache(FP_OFF(pic),i);

	for(i=0;i<MAXTILES;i++)
	{
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizx[i])) j--;
		picsiz[i] = ((char)j);
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizy[i])) j--;
		picsiz[i] += ((char)(j<<4));
	}

	picsloaded = 1;

	artfil = -1;
	artfilnum = -1;
	artfilplc = 0L;

	return(0);
}

unloadpics()
{
	if (artfil != -1) close(artfil);
	if (pic != NULL) { free(pic); pic = NULL; }
	picsloaded = 0;
}

savepicanms()
{
	short fil;
	long k;

	for(k=0;k<numtilefiles;k++)
	{
		artfilename[7] = (k%10)+48;
		artfilename[6] = ((k/10)%10)+48;
		artfilename[5] = ((k/100)%10)+48;
		if ((fil = open(artfilename,O_BINARY|O_WRONLY,S_IWRITE)) != -1)
		{
			lseek(fil,16+((localtileend[k]-localtilestart[k]+1)<<2),SEEK_SET);
			write(fil,&picanm[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<2);
			close(fil);
		}
	}
	return(0);
}

load2board(char filename[20], short boardnum, long *daposx, long *daposy, long *dazoom, short *daang)
{
	long fil, i, j;

	curboardbytes = 0;
	initspritelists();

	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&mapversion,4);
		if (mapversion != 0x00010000) return(-1);
		read(fil,&nummaps,2);
		if ((boardnum < 0) || (boardnum >= MAXMAPS)) return(-1);
		if (boardnum >= nummaps)
		{
			numsprites[boardnum] = 0;

			*daposx = 8388608*32;   //Center of board
			*daposy = 8388608*32;   //Center of board
			*dazoom = 65536;
			*daang = 0;

			for(j=0;j<4096;j++)
			{
				if (((j&63) == 0) || ((j&63) == 63) || ((j>>6) == 0) || ((j>>6) == 63))
					board2d[j] = 1;
				else if ((j == (31<<6)+31) || (j == (32<<6)+31) || (j == (31<<6)+32) || (j == (32<<6)+32))
					board2d[j] = 1;
				else
					board2d[j] = 0;
			}

		}
		else
		{
			read(fil,&numsprites[0],MAXMAPS<<1);

			i = 4+2+(MAXMAPS<<1);                        //Global header
			for(j=0;j<boardnum;j++)
				i += (4+4+4+2+8192+(numsprites[j]*18));   //Individual map header
			curboardbytes = (4+4+4+2+8192+(numsprites[boardnum]*18));
			lseek(fil,i,SEEK_SET);

			read(fil,daposx,4);
			read(fil,daposy,4);
			read(fil,dazoom,4);
			read(fil,daang,2);

			read(fil,&board2d[0],(unsigned short)8192);
			for(i=0;i<numsprites[boardnum];i++)
			{
				read(fil,&j,2);
				j = insertsprite((short)j);
				read(fil,&spritex[j],4);
				read(fil,&spritey[j],4);
				read(fil,&spritezoom[j],4);
				read(fil,&spritepicnum[j],2);
				read(fil,&spriteang[j],2);
			}
		}
		close(fil);
	}
	else
		return(-1);
	return(0);
}

save2board(char filename[20], short boardnum, long daposx, long daposy, long dazoom, short daang)
{
	long fil, i, j, savestartoffs, fileend, newcurboardbytes, delta, numbytes;

	if ((fil = open(filename,O_BINARY|O_CREAT|O_RDWR,S_IREAD|S_IWRITE)) != -1)
	{
		if (boardnum >= nummaps)
		{
			boardnum = nummaps;
			nummaps++;
		}

		numsprites[boardnum] = 0;
		for(i=0;i<MAXSPRITES;i++)
			if (spritestat[i] < MAXSTATUS)
				numsprites[boardnum]++;

		fileend = filelength(fil);

		write(fil,&mapversion,4);
		write(fil,&nummaps,2);
		write(fil,&numsprites[0],MAXMAPS<<1);

		savestartoffs = 4+2+(MAXMAPS<<1);                        //Global header
		for(j=0;j<boardnum;j++)
			savestartoffs += (4+4+4+2+8192+(numsprites[j]*18));   //Individual map header
		newcurboardbytes = (4+4+4+2+8192+(numsprites[boardnum]*18));

		if (boardnum < nummaps-1)
		{
			delta = newcurboardbytes-curboardbytes;
			if (delta > 0)  //insert
			{
				i = savestartoffs+curboardbytes;
				i += (((fileend-curboardbytes-1)>>12)<<12);
				while (i >= savestartoffs+curboardbytes)
				{
					lseek(fil,i,SEEK_SET);
					numbytes = read(fil,&tempbuf[0],4096);
					lseek(fil,i+delta,SEEK_SET);
					write(fil,&tempbuf[0],numbytes);
					i -= 4096;
				}
			}
			else if (delta < 0)  //delete
			{
				i = savestartoffs+curboardbytes;
				do
				{
					lseek(fil,i,SEEK_SET);
					numbytes = read(fil,&tempbuf[0],4096);
					lseek(fil,i+delta,SEEK_SET);
					write(fil,&tempbuf[0],numbytes);
					i += 4096;
				}
				while (numbytes == 4096);
			}
		}

		lseek(fil,savestartoffs,SEEK_SET);
		write(fil,&daposx,4);
		write(fil,&daposy,4);
		write(fil,&dazoom,4);
		write(fil,&daang,2);
		write(fil,&board2d[0],(unsigned short)8192);
		for(i=0;i<MAXSPRITES;i++)
			if (spritestat[i] < MAXSTATUS)
			{
				write(fil,&spritestat[i],2);
				write(fil,&spritex[i],4);
				write(fil,&spritey[i],4);
				write(fil,&spritezoom[i],4);
				write(fil,&spritepicnum[i],2);
				write(fil,&spriteang[i],2);
			}
	}
	close(fil);
}

draw2board(long daposx, long daposy, long dazoom, short daang)
{
	long cosang, sinang, i, j, plane, um, dm, x, x2, y, y2, p, p2, ox, oy;

	globalposx = daposx;
	globalposy = daposy;
	globalang = daang;
	if (dazoom != 0) globalzoom = divscale16(65536,dazoom);

	globalcosang = divscale14((long)sintable[(daang+2560)&2047],dazoom);
	globalsinang = divscale14((long)sintable[(daang)&2047],dazoom);
	cosang = mulscale14((long)sintable[(daang+2560)&2047],dazoom);
	sinang = mulscale14((long)sintable[(daang)&2047],dazoom);

	x = (daposx>>2) - cosang*(pivotx-clipxlo[0]) + sinang*(pivoty);
	y = (daposy>>2) - sinang*(pivotx-clipxlo[0]) - cosang*(pivoty);

	setupdrawbackmach(-sinang<<8,cosang<<8,0L,0L,0L,0L);

	if (chainstat)
	{
		ox = x; oy = y;
		koutp(0x3c4,2);
		for(plane=0;plane<4;plane++)
		{
			faketimerhandler();

			x = ox; y = oy;
			koutp(0x3c5,1<<plane);

			p = (clipxlo[0]>>2)+chainplace;
			for(i=clipxlo[0];i<clipxlo[1];i+=8)
			{
				um = clipylo[0]; dm = clipylo[1]-1;
				if (um <= dm)
				{
					x2 = x - sinang*um;
					y2 = y + cosang*um;
					p2 = p + ylookup[um];

					asm1 = (((x2+(cosang<<2)+plane)<<16)&0xffff0000);
					asm3 = ((x2>>13)&0x3f00)+((y2>>19)&0xfc);                     //boardx1 boardy1
					asm4 = (((x2+(cosang<<2))>>13)&0x3f00)+(((y2+(sinang<<2))>>19)&0xfc);   //boardx2 boardy2

					drawback(((x2>>8)&0x1f00)+((y2>>16)&0x1f),                      //char tileoffs1
							 (y2<<16)&0xffff0000,
							 (((y2+(sinang<<2))<<16)&0xffff0000)+(dm-um),
							 (((x2+(cosang<<2))>>8)&0x1f00)+(((y2+(sinang<<2))>>16)&0x1f),    //char tileoffs2
							 (x2<<16)&0xffff0000,
							 p2);
				}
				x += (cosang<<3);
				y += (sinang<<3);
				p += 2;
			}
			ox += cosang;
			oy += sinang;
		}
	}
	else
	{
		p = frameplace + clipxlo[0];
		for(i=clipxlo[0];i<clipxlo[1];i+=2)
		{
			if ((i&63) == 0) faketimerhandler();

			um = clipylo[0]; dm = clipylo[1]-1;
			if (um <= dm)
			{
				x2 = x - sinang*um;
				y2 = y + cosang*um;
				p2 = p + ylookup[um];

				asm1 = (((x2+cosang)<<16)&0xffff0000);
				asm3 = ((x2>>13)&0x3f00)+((y2>>19)&0xfc);                     //boardx1 boardy1
				asm4 = (((x2+cosang)>>13)&0x3f00)+(((y2+sinang)>>19)&0xfc);   //boardx2 boardy2

				drawback(((x2>>8)&0x1f00)+((y2>>16)&0x1f),                    //char tileoffs1
						 (y2<<16)&0xffff0000,
						 (((y2+sinang)<<16)&0xffff0000)+(dm-um),
						 (((x2+cosang)>>8)&0x1f00)+(((y2+sinang)>>16)&0x1f),    //char tileoffs2
						 (x2<<16)&0xffff0000,
						 p2);
			}
			x += (cosang<<1);
			y += (sinang<<1);
			p += 2;
		}
	}
}

drawsprite (long sx, long sy, long z, short a, short picnum, char col)
{
	char *ptr;
	long relz, rela, xdime, ydime, cosang, sinang, npoints, dacol, zrecip;
	long cx, cy, xv, yv, gx1, gy1, x1, y1, x2, y2, x3, y3, x4, y4;
	long x, y, oy, i, lx, rx, dax, v, nextv, xsiz, ysiz, xoff, yoff;
	long dax1, dax2, yinc, yplc, bx, by, obx, oby, p, um, dm, plane;

	if (z <= 16) return;

	if (picanm[picnum] != 0)
	{
		switch(picanm[picnum]&192)
		{
			case 64:
				i = (numframes%((picanm[picnum]&63)<<1));
				if (i < (picanm[picnum]&63))
					picnum += i;
				else
					picnum += (((picanm[picnum]&63)<<1)-i);
				break;
			case 128:
				picnum += (numframes%((picanm[picnum]&63)+1));
					break;
			case 192:
				picnum -= (numframes%((picanm[picnum]&63)+1));
		}
	}

	xsiz = tilesizx[picnum]; if (xsiz <= 0) return;
	ysiz = tilesizy[picnum]; if (ysiz <= 0) return;
	xoff = (long)((signed char)((picanm[picnum]>>8)&255))+(xsiz>>1);
	yoff = (long)((signed char)((picanm[picnum]>>16)&255))+(ysiz>>1);

	cx = (pivotx<<16)+dmulscale14(globalcosang,sx-globalposx,+globalsinang,sy-globalposy);
	cy = (pivoty<<16)+dmulscale14(globalcosang,sy-globalposy,-globalsinang,sx-globalposx);

	rela = (long)((a-globalang)&2047);
	relz = mulscale16(z,globalzoom);

	cosang = sintable[(rela+512)&2047]; sinang = sintable[rela];
	zrecip = divscale32(1L,relz);
	xv = mulscale14(cosang,zrecip);
	yv = mulscale14(sinang,zrecip);
	cosang = mulscale14(cosang,relz);
	sinang = mulscale14(sinang,relz);

	py[0] = cy - (sinang*xoff + cosang*yoff);
	py[1] = py[0] + sinang*xsiz;
	py[3] = py[0] + cosang*ysiz;
	py[2] = py[1]+py[3]-py[0];
	i = clipy[0]; if ((py[0]<i) && (py[1]<i) && (py[2]<i) && (py[3]<i)) return;
	i = clipy[1]; if ((py[0]>i) && (py[1]>i) && (py[2]>i) && (py[3]>i)) return;

	px[0] = cx - (cosang*xoff - sinang*yoff);
	px[1] = px[0] + cosang*xsiz;
	px[3] = px[0] - sinang*ysiz;
	px[2] = px[1]+px[3]-px[0];
	i = clipx[0]; if ((px[0]<i) && (px[1]<i) && (px[2]<i) && (px[3]<i)) return;
	i = clipx[1]; if ((px[0]>i) && (px[1]>i) && (px[2]>i) && (px[3]>i)) return;

		//setup getreadpos
	gx1 = px[0]; gy1 = py[0];

	if ((npoints = clippoly4()) < 3) return;

	lx = px[0]; rx = px[0];
	nextv = 0;
	for(v=npoints-1;v>=0;v--)
	{
		x1 = px[v]; x2 = px[nextv];
		dax1 = ((x1+32768)>>16); lx = min(lx,x1);
		dax2 = ((x2+32768)>>16); rx = max(rx,x1);
		if (dax1 != dax2)
		{
			y1 = py[v]; y2 = py[nextv];
			yinc = divscale16(y2-y1,x2-x1);
			if (dax2 > dax1)
			{
				yplc = y1 + mulscale16((dax1<<16)+32768-x1,yinc) + 32768;
				qinterpolatedown16short((long)(&topy[dax1]),dax2-dax1,yplc,yinc);
			}
			else
			{
				yplc = y2 + mulscale16((dax2<<16)+32768-x2,yinc) + 32768;
				qinterpolatedown16short((long)(&boty[dax2]),dax1-dax2,yplc,yinc);
			}
		}
		nextv = v;
	}

	if (waloff[picnum] == 0) loadtile(picnum);
	setupdrawspritemach(yv,xv,waloff[picnum]);
	setupsolidspritemach(col!=255);
	dacol = (((long)col)<<8);

	x1 = ((lx+32768)>>16); x2 = ((rx+32768)>>16);

	if (chainstat)
	{
		x = x1;

		oy = topy[x];
		x3 = (x<<16)+32768-gx1;
		y3 = (oy<<16)+32768-gy1;
		bx = dmulscale16(y3,yv,x3,xv);
		by = dmulscale16(y3,xv,-x3,yv);
		obx = bx;
		oby = by;

		koutp(0x3c4,2);
		for(plane=0;plane<4;plane++)
		{
			x = x1+plane;
			koutp(0x3c5,1<<(x&3));

			bx = obx; obx += xv;
			by = oby; oby -= yv;
			oy = topy[x1];

			while (x < x2)
			{
				y1 = topy[x]; y3 = topy[x+4];
				y2 = boty[x]; y4 = boty[x+4];

				if (y2 > y1)
				{
					if ((y4 > y3) && (x < x2-4) && (col == 255))
					{
						um = y1; if (y3 > um) um = y3;
						dm = y2; if (y4 < dm) dm = y4;

						if (y1 < um)
						{
							p = ylookup[y1]+(x>>2)+chainplace;
							if (oy != y1)
								i = y1-oy, oy = y1, bx += yv*i, by += xv*i;
							drawspritevline1(bx,by,((um-y1-1)<<16),0L,0L,p);
						}
						else if (y3 < um)
						{
							p = ylookup[y3]+(x>>2)+chainplace;
							if (oy != y3)
								i = y3-oy, oy = y3, bx += yv*i, by += xv*i;
							drawspritevline1(bx+(xv<<2),by-(yv<<2),((um-y3-1)<<16),0L,0L,p+1);
						}

						if (dm > um)
						{
							p = ylookup[um]+(x>>2)+chainplace;

							if (oy != um)
								i = um-oy, oy = um, bx += yv*i, by += xv*i;

							asm1 = (((bx+(xv<<2))<<16)&0xffff0000);
							drawspritevline2((by<<16)&0xffff0000,   //char tileoffs1
								 ((bx>>8)&0xff00)+((by>>16)&0xff),
								 (((by-(yv<<2))<<16)&0xffff0000)+(dm-um-1),
								 (((bx+(xv<<2))>>8)&0xff00)+(((by-(yv<<2))>>16)&0xff),    //char tileoffs2
								 (bx<<16)&0xffff0000,
								 p);
						}

						if (y2 > dm)
						{
							p = ylookup[dm]+(x>>2)+chainplace;
							if (oy != dm)
								i = dm-oy, oy = dm, bx += yv*i, by += xv*i;
							drawspritevline1(bx,by,((y2-dm-1)<<16),0L,0L,p);
						}
						else if (y4 > dm)
						{
							p = ylookup[dm]+(x>>2)+chainplace;
							if (oy != dm)
								i = dm-oy, oy = dm, bx += yv*i, by += xv*i;
							drawspritevline1(bx+(xv<<2),by-(yv<<2),((y4-dm-1)<<16),0L,0L,p+1);
						}

						bx += (xv<<2); by -= (yv<<2); x += 4;
					}
					else
					{
						p = ylookup[y1]+(x>>2)+chainplace;

						if (oy != y1)
							i = y1-oy, oy = y1, bx += yv*i, by += xv*i;
						drawspritevline1(bx,by,((y2-y1-1)<<16)+dacol,0L,0L,p);
					}
				}

				bx += (xv<<2); by -= (yv<<2); x += 4;
			}
		}
	}
	else
	{
		x = x1;

		oy = topy[x];
		x3 = (x<<16)+32768-gx1;
		y3 = (oy<<16)+32768-gy1;
		bx = dmulscale16(y3,yv,x3,xv);
		by = dmulscale16(y3,xv,-x3,yv);

		while (x < x2)
		{
			y1 = topy[x]; y3 = topy[x+1];
			y2 = boty[x]; y4 = boty[x+1];

			if (y2 > y1)
			{
				if ((y4 > y3) && (x < x2-1) && ((x&1) == 0) && (col == 255))
				{
					um = y1; if (y3 > um) um = y3;
					dm = y2; if (y4 < dm) dm = y4;

					if (y1 < um)
					{
						p = ylookup[y1]+x+frameplace;
						if (oy != y1)
							i = y1-oy, oy = y1, bx += yv*i, by += xv*i;
						drawspritevline1(bx,by,((um-y1-1)<<16),0L,0L,p);
					}
					else if (y3 < um)
					{
						p = ylookup[y3]+x+frameplace;
						if (oy != y3)
							i = y3-oy, oy = y3, bx += yv*i, by += xv*i;
						drawspritevline1(bx+xv,by-yv,((um-y3-1)<<16),0L,0L,p+1);
					}

					if (dm > um)
					{
						p = ylookup[um]+x+frameplace;

						if (oy != um)
							i = um-oy, oy = um, bx += yv*i, by += xv*i;

						asm1 = (((bx+xv)<<16)&0xffff0000);
						drawspritevline2((by<<16)&0xffff0000,   //char tileoffs1
							 ((bx>>8)&0xff00)+((by>>16)&0xff),
							 (((by-yv)<<16)&0xffff0000)+(dm-um-1),
							 (((bx+xv)>>8)&0xff00)+(((by-yv)>>16)&0xff),    //char tileoffs2
							 (bx<<16)&0xffff0000,
							 p);
					}

					if (y2 > dm)
					{
						p = ylookup[dm]+x+frameplace;
						if (oy != dm)
							i = dm-oy, oy = dm, bx += yv*i, by += xv*i;
						drawspritevline1(bx,by,((y2-dm-1)<<16),0L,0L,p);
					}
					else if (y4 > dm)
					{
						p = ylookup[dm]+x+frameplace;
						if (oy != dm)
							i = dm-oy, oy = dm, bx += yv*i, by += xv*i;
						drawspritevline1(bx+xv,by-yv,((y4-dm-1)<<16),0L,0L,p+1);
					}

					bx += xv; by -= yv; x++;
				}
				else
				{
					p = ylookup[y1]+x+frameplace;

					if (oy != y1)
						i = y1-oy, oy = y1, bx += yv*i, by += xv*i;
					drawspritevline1(bx,by,((y2-y1-1)<<16)+dacol,0L,0L,p);
				}
			}

			bx += xv; by -= yv; x++;
		}
	}

	faketimerhandler();

	//while (cnt > 0)
	//{
	//   ptr = (char *)(bufplc+((bx>>16)<<8)+(by>>16));
	//   dat = (long)(*ptr);
	//   if (dat != 255) drawpixel(p,dat);
	//   bx += bxinc;
	//   by += byinc;
	//   p += 80, 320, or 640;
	//   cnt--;
	//}
}

clippoly4()   //Assume npoints=4 with polygon on &px,&py
{
	long n, nn, z, zz, x, x1, x2, y, y1, y2, t;

	nn = 0; z = 0;
	do
	{
		zz = ((z+1)&3);
		x1 = px[z]; x2 = px[zz]-x1;

		if ((clipx[0] <= x1) && (x1 <= clipx[1]))
			npx[nn] = x1, npy[nn] = py[z], nn++;

		x = clipx[x2<=0]; t = x-x1;
		if (((t-x2)^t) < 0)
			npx[nn] = x, npy[nn] = py[z]+scale(t,py[zz]-py[z],x2), nn++;

		x ^= clipxxor; t = x-x1;
		if (((t-x2)^t) < 0)
			npx[nn] = x, npy[nn] = py[z]+scale(t,py[zz]-py[z],x2), nn++;

		z = zz;
	} while (z != 0);
	if (nn < 3) return(0);

	n = 0; z = 0;
	do
	{
		zz = z+1; if (zz == nn) zz = 0;
		y1 = npy[z]; y2 = npy[zz]-y1;

		if ((clipy[0] <= y1) && (y1 <= clipy[1]))
			py[n] = y1, px[n] = npx[z], n++;

		y = clipy[y2<=0]; t = y-y1;
		if (((t-y2)^t) < 0)
			py[n] = y, px[n] = npx[z]+scale(t,npx[zz]-npx[z],y2), n++;

		y ^= clipyxor; t = y-y1;
		if (((t-y2)^t) < 0)
			py[n] = y, px[n] = npx[z]+scale(t,npx[zz]-npx[z],y2), n++;

		z = zz;
	} while (z != 0);
	return(n);
}

permanentwritesprite (long thex, long they, short tilenum)
{
	char *ptr;
	unsigned char dat;
	long xsiz, ysiz, x, y, x1, y1, x2, y2, p, pinc, tileoffs, bufplc;
	long dapage, dachainplace;

	pinc = ylookup[1];

	if (waloff[tilenum] == 0) loadtile(tilenum);
	tileoffs = waloff[tilenum];
	xsiz = tilesizx[tilenum];
	ysiz = tilesizy[tilenum];

	x1 = thex;
	y1 = they;
	x2 = x1 + xsiz;
	y2 = y1 + ysiz;
	if ((x2 < 0) || (x1 >= xdim) || (y2 < 0) || (y1 >= ydim))
		return(0);

	if (chainstat) dachainplace = 0xa0000;

	for (dapage=0;dapage<numpages;dapage++)
	{
		for(x=x1;x<x2;x++)
			if ((x >= 0) && (x < xdim))
			{
				ptr = (char *)(tileoffs+((x-x1)<<8));
				if (y1 < 0) ptr -= y1, y1 = 0;
				if (y2 > ydim) y2 = ydim;

				if (chainstat)
				{
					p = ylookup[y1]+(x>>2)+dachainplace;
					koutpw(0x3c4,2+(256<<(x&3)));
				}
				else
				{
					if (vidoption == 1) setactivepage(dapage);
					if (vidoption == 3) koutp(0x3cd,dapage+(dapage<<4));
					if (vidoption == 4) koutpw(0x3ce,0x09+(dapage<<12));
					if (vidoption == 5) koutpw(0x3d4,0x35+(dapage<<8));
					if (vidoption == 6) koutpw(0x3ce,0x09+(dapage<<10));
					p = ylookup[y1] + x+frameplace;
				}

				for(y=y1;y<y2;y++)
				{
					dat = *ptr;
					if (dat != 255)
						drawpixel(p,dat);
					p += pinc;
					ptr++;
				}
			}
		if (chainstat) dachainplace += chainsiz;
	}

	if (vidoption == 1) setactivepage(page);
	if (vidoption == 3) koutp(0x3cd,page+(page<<4));
	if (vidoption == 4) koutpw(0x3ce,0x9+(page<<12));
	if (vidoption == 5) koutpw(0x3d4,0x35+(page<<8));
	if (vidoption == 6) koutpw(0x3ce,0x09+(page<<10));

	return(0);
}

initspritelists()
{
	long i;

	for(i=0;i<MAXSTATUS;i++)      //Init doubly-linked sprite status lists
		headsprite[i] = -1;
	headsprite[MAXSTATUS] = 0;
	for(i=0;i<MAXSPRITES;i++)
	{
		prevsprite[i] = i-1;
		nextsprite[i] = i+1;
		spritestat[i] = MAXSTATUS;
	}
	prevsprite[0] = -1;
	nextsprite[MAXSPRITES-1] = -1;
}

insertsprite(short statnum)
{
	short blanktouse;

	if ((statnum >= MAXSTATUS) || (headsprite[MAXSTATUS] == -1))
		return(-1);  //list full

	blanktouse = headsprite[MAXSTATUS];

	headsprite[MAXSTATUS] = nextsprite[blanktouse];
	if (headsprite[MAXSTATUS] >= 0)
		prevsprite[headsprite[MAXSTATUS]] = -1;

	prevsprite[blanktouse] = -1;
	nextsprite[blanktouse] = headsprite[statnum];
	if (headsprite[statnum] >= 0)
		prevsprite[headsprite[statnum]] = blanktouse;
	headsprite[statnum] = blanktouse;

	spritestat[blanktouse] = statnum;

	return(blanktouse);
}

deletesprite (short deleteme)
{
	if (spritestat[deleteme] == MAXSTATUS)
		return(-1);

	if (headsprite[spritestat[deleteme]] == deleteme)
		headsprite[spritestat[deleteme]] = nextsprite[deleteme];

	if (prevsprite[deleteme] >= 0) nextsprite[prevsprite[deleteme]] = nextsprite[deleteme];
	if (nextsprite[deleteme] >= 0) prevsprite[nextsprite[deleteme]] = prevsprite[deleteme];

	if (headsprite[MAXSTATUS] >= 0) prevsprite[headsprite[MAXSTATUS]] = deleteme;
	prevsprite[deleteme] = -1;
	nextsprite[deleteme] = headsprite[MAXSTATUS];
	headsprite[MAXSTATUS] = deleteme;

	spritestat[deleteme] = MAXSTATUS;
	return(0);
}

changespritestat(short spritenum, short newstatnum)
{
	if (spritestat[spritenum] == newstatnum) return(-1);
	if (spritestat[spritenum] == MAXSTATUS) return(-1);
	if (deletesprite(spritenum) < 0) return(-1);
	insertsprite(newstatnum);
	return(0);
}

clipmove (long *x, long *y, long xvect, long yvect, long walldist, char clipmask)
{
	short hitwall, cnt;
	long goalx, goaly, intx, inty;

	if ((xvect|yvect) == 0) return(1);

	goalx = *x + xvect;
	goaly = *y + yvect;

	getcliplines(*x, *y, goalx, goaly, walldist, clipmask);

	cnt = 0;

	while ((xvect|yvect) != 0)
	{
		hitwall = raytrace(*x, *y, goalx, goaly, &intx, &inty);

		if (hitwall >= 0)
		{
			cnt++;
			if (hitwall == 0)   //hit vertical line
			{
				xvect = 0;
				yvect = goaly - inty;
				goalx = intx + xvect;
				goaly = inty + yvect;
			}
			else                 //hit horizontal line
			{
				xvect = goalx - intx;
				yvect = 0;
				goalx = intx + xvect;
				goaly = inty + yvect;
			}
		}
		else
		{
			xvect = 0;
			yvect = 0;
		}

		*x = intx;
		*y = inty;
	}

	if (cnt == 0)
		return(1);
	else
		return(0);
}

getcliplines (long x, long y, long goalx, long goaly, long walldist, char clipmask)
{
	short bx1, by1, bx2, by2, xx, yy;
	long xmin, ymin, xmax, ymax, dax, day;

	clipnum = 0;

	xmin = x; ymin = y;
	xmax = goalx; ymax = goaly;
	if (xmax < xmin) dax = xmin, xmin = xmax, xmax = dax;
	if (ymax < ymin) day = ymin, ymin = ymax, ymax = day;
	xmin -= (walldist+8);
	xmax += (walldist+8);
	ymin -= (walldist+8);
	ymax += (walldist+8);
	bx1 = (xmin>>23); by1 = (ymin>>23);
	bx2 = (xmax>>23); by2 = (ymax>>23);

	for (xx=bx1;xx<=bx2;xx++)
		for (yy=by1;yy<=by2;yy++)
			if (((picanm[board2d[((xx&63)<<6)+(yy&63)]]>>24)&clipmask) != 0)
			{
				dax = (xx<<23);
				day = (yy<<23);

				if (goalx > x)
				{
					if (((picanm[board2d[(((xx+63)&63)<<6)+(yy&63)]]>>24)&clipmask) == 0)
					{
						clipx1[clipnum] = dax - walldist;
						clipy1[clipnum] = day - walldist;
						clipx2[clipnum] = dax - walldist;
						clipy2[clipnum] = day + walldist + 8388608;
						clipnum++;
					}
				}
				else
				{
					if (((picanm[board2d[(((xx+1)&63)<<6)+(yy&63)]]>>24)&clipmask) == 0)
					{
						clipx1[clipnum] = dax + walldist + 8388608;
						clipy1[clipnum] = day - walldist;
						clipx2[clipnum] = dax + walldist + 8388608;
						clipy2[clipnum] = day + walldist + 8388608;
						clipnum++;
					}
				}

				if (goaly > y)
				{
					if (((picanm[board2d[((xx&63)<<6)+((yy+63)&63)]]>>24)&clipmask) == 0)
					{
						clipx1[clipnum] = dax - walldist;
						clipy1[clipnum] = day - walldist;
						clipx2[clipnum] = dax + walldist + 8388608;
						clipy2[clipnum] = day - walldist;
						clipnum++;
					}
				}
				else
				{
					if (((picanm[board2d[((xx&63)<<6)+((yy+1)&63)]]>>24)&clipmask) == 0)
					{
						clipx1[clipnum] = dax - walldist;
						clipy1[clipnum] = day + walldist + 8388608;
						clipx2[clipnum] = dax + walldist + 8388608;
						clipy2[clipnum] = day + walldist + 8388608;
						clipnum++;
					}
				}
			}
}

raytrace (long x3, long y3, long x4, long y4, long *intx, long *inty)
{
	short hitwall, bad, z;
	long x1, y1, x2, y2, nintx, ninty;

	*intx = x4; *inty = y4;

	hitwall = -1;
	for(z=0;z<clipnum;z++)
	{
		x1 = clipx1[z]; y1 = clipy1[z];
		x2 = clipx2[z]; y2 = clipy2[z];

		bad = 1;
		if ((x1 == x2) && (x3 != x4))
		{
			nintx = x1;
			if (((x3 <= nintx) && (nintx <= x4)) || ((x4 <= nintx) && (nintx <= x3)))
			{
				ninty = y3 + scale(nintx-x3,y4-y3,x4-x3);
				if ((ninty > y1) && (ninty < y2)) bad = 0;
			}
		}
		if ((y1 == y2) && (y3 != y4))
		{
			ninty = y1;
			if (((y3 <= ninty) && (ninty <= y4)) || ((y4 <= ninty) && (ninty <= y3)))
			{
				nintx = x3 + scale(ninty-y3,x4-x3,y4-y3);
				if ((nintx > x1) && (nintx < x2)) bad = 0;
			}
		}

		if (bad == 0)
		{
			if (klabs(x3-nintx)+klabs(y3-ninty) < klabs(x3-*intx)+klabs(y3-*inty))
			{
				*intx = nintx;
				*inty = ninty;
				hitwall = (x1!=x2);
			}
		}
	}

	return(hitwall);
}

krand()
{
	randomseed = (randomseed*27584621)+1;
	return(((unsigned long)randomseed)>>16);
}

getangle(long xvect, long yvect)
{
	if ((xvect|yvect) == 0) return(0);
	if (xvect == 0) return(512+((yvect<0)<<10));
	if (yvect == 0) return(((xvect<0)<<10));
	if (xvect == yvect) return(256+((xvect<0)<<10));
	if (xvect == -yvect) return(768+((xvect>0)<<10));
	if (klabs(xvect) > klabs(yvect))
		return(((radarang[640+scale(160,yvect,xvect)]>>6)+((xvect<0)<<10))&2047);
	return(((radarang[640-scale(160,xvect,yvect)]>>6)+512+((yvect<0)<<10))&2047);
}

ksqrt(long num)
{
	long root, temp;

	if (num < 0)
		return(-1);
	root = 128;
	do
	{
		temp = root;
		root = ((root+(num/root))>>1);
	}
	while (klabs(temp-root) > 1);
	return(root);
}

canmovethrough(long x1, long y1, long x2, long y2, char daclipmask)
{
	long incrx, incry, snx, sny, xdir, ydir, cnt, gridx, gridy, dacnt;

	if (x2 > x1)
		incrx = ((x2-x1)>>13), xdir = 1;
	else
		incrx = ((x1-x2)>>13), xdir = -1;

	if (y2 > y1)
		incry = ((y2-y1)>>13), ydir = 1;
	else
		incry = ((y1-y2)>>13), ydir = -1;

	snx = ((x1>>13)&1023); if (xdir == 1) snx = 1024-snx;
	sny = ((y1>>13)&1023); if (ydir == 1) sny = 1024-sny;
	cnt = snx*incry - sny*incrx;
	incrx <<= 10; incry <<= 10;
	gridx = (x1>>23); gridy = (y1>>23);

	dacnt = klabs((x2>>23)-gridx) + klabs((y2>>23)-gridy);
	do
	{
		if (((picanm[board2d[((gridx&63)<<6)+(gridy&63)]]>>24)&daclipmask) != 0) return(0);
		if (cnt < 0)
		{
			cnt += incry;
			gridx += xdir;
		}
		else
		{
			cnt -= incrx;
			gridy += ydir;
		}
		dacnt--;
	} while (dacnt >= 0);

	return(1);
}

printext256(long xpos, long ypos, short col, short backcol, char *name, char fontsize)
{
	long stx, zx, stupidbitoffset, x, y, charxsiz;
	short dat, dacol;
	char *fontptr;

	stx = xpos;

	if (fontsize == 1)
	{
		fontptr = smalltextfont;
		charxsiz = 4;
		stupidbitoffset = 1;
	}
	else
	{
		fontptr = textfont;
		charxsiz = 8;
		stupidbitoffset = 0;
	}

	for(zx=0;zx<strlen(name);zx++)
	{
		dat = name[zx];

		for(y=0;y<8;y++)
			for(x=0;x<charxsiz;x++)
			{
				if ((fontptr[(dat<<3)+y]&(1<<(7-stupidbitoffset-x))) > 0)
					dacol = (short)col;
				else if (backcol >= 0)
					dacol = (short)backcol;
				else
					dacol = -1;

				if (dacol >= 0)
				{
					if (chainstat)
					{
						koutpw(0x3c4,2+(256<<((x+stx-stupidbitoffset)&3)));
						drawpixel(ylookup[y+ypos]+((x+stx-stupidbitoffset)>>2)+chainplace,(long)dacol);
					}
					else
						drawpixel(ylookup[y+ypos]+(x+stx-stupidbitoffset)+frameplace,(long)dacol);
				}
			}

		stx += charxsiz;
	}
}

initmouse()
{
	return(setupmouse());
}

getmousevalues(short *mousx, short *mousy, short *bstatus)
{
	readmousexy(mousx,mousy);
	readmousebstatus(bstatus);
}

setview(long x1, long y1, long x2, long y2)
{
	clipx[0] = (x1<<16); clipxlo[0] = x1;
	clipy[0] = (y1<<16); clipylo[0] = y1;
	clipx[1] = ((x2+1)<<16); clipxlo[1] = x2+1;
	clipy[1] = ((y2+1)<<16); clipylo[1] = y2+1;
	clipxxor = (clipx[0]^clipx[1]);
	clipyxor = (clipy[0]^clipy[1]);
}

screencapture()
{
	char filename[15], *ptr;
	long fil, i, bufplc, p, col, ncol, leng, numbytes, xres;

	strcpy(filename,"capturxx.pcx");
	filename[6] = (capturecount/10)+48;
	filename[7] = (capturecount%10)+48;
	capturecount++;
	if ((fil=open(filename,O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IWRITE))==-1)
	{
		capturecount--;
		return(-1);
	}

	pcxheader[8] = ((xdim-1)&255); pcxheader[9] = (((xdim-1)>>8)&255);
	pcxheader[10] = ((ydim-1)&255); pcxheader[11] = (((ydim-1)>>8)&255);
	pcxheader[12] = (xdim&255); pcxheader[13] = ((xdim>>8)&255);
	pcxheader[14] = (ydim&255); pcxheader[15] = ((ydim>>8)&255);
	pcxheader[66] = (xdim&255); pcxheader[67] = ((xdim>>8)&255);

	write(fil,&pcxheader[0],128);

	if (chainstat)
	{
		ptr = (char *)chainplace;
		xres = (xdim>>2);
	}
	else
	{
		ptr = (char *)frameplace;
		xres = xdim;
	}
	numbytes = xdim*ydim;

	bufplc = 0;
	p = 0;
	while (p < numbytes)
	{
		koutp(97,kinp(97)|3);

		if (chainstat)
		{
			koutpw(0x3ce,4+((p&3)<<8)); col = *ptr;
			p++; if ((p&3) == 0) ptr++;
		}
		else
		{
			col = *ptr;
			p++; ptr++;
		}

		leng = 1;

		if (chainstat)
		{
			koutpw(0x3ce,4+((p&3)<<8)); ncol = *ptr;
		}
		else
		{
			ncol = *ptr;
		}

		while ((ncol == col) && (p < numbytes) && (leng < 63) && ((p%xres) != 0))
		{
			leng++;

			if (chainstat)
			{
				p++; if ((p&3) == 0) ptr++;
				koutpw(0x3ce,4+((p&3)<<8)); ncol = *ptr;
			}
			else
			{
				p++; ptr++;
				ncol = *ptr;
			}
		}

		koutp(97,kinp(97)&252);

		if ((leng > 1) || (col >= 0xc0))
		{
			tempbuf[bufplc++] = (leng|0xc0);
			if (bufplc == 256)
			{
				if (write(fil,&tempbuf[0],256) < 256)
				{
					close(fil); capturecount--; return(-1);
				}
				bufplc = 0;
			}
		}
		tempbuf[bufplc++] = col;
		if (bufplc == 256)
		{
			if (write(fil,&tempbuf[0],256) < 256)
			{
				close(fil); capturecount--; return(-1);
			}
			bufplc = 0;
		}
	}

	tempbuf[bufplc++] = 0xc;
	if (bufplc == 256)
	{
		if (write(fil,&tempbuf[0],256) < 256)
		{
			close(fil); capturecount--; return(-1);
		}
		bufplc = 0;
	}

	koutp(0x3c7,0);
	for(i=0;i<768;i++)
	{
		tempbuf[bufplc++] = (kinp(0x3c9)<<2);
		if (bufplc == 256)
		{
			if (write(fil,&tempbuf[0],256) < 256)
			{
				close(fil); capturecount--; return(-1);
			}
			bufplc = 0;
		}
	}

	if (bufplc > 0)
		if (write(fil,&tempbuf[0],bufplc) < bufplc)
		{
			close(fil); capturecount--; return(-1);
		}
	close(fil);
	return(0);
}

plotpixel(long x, long y, char col)
{
	if (chainstat)
	{
		outpw(0x3c4,2+(256<<(x&3)));
		drawpixel(ylookup[y]+(x>>2)+chainplace,(long)col);
	}
	else
	{
		drawpixel(ylookup[y]+x+frameplace,(long)col);
	}
}

char getpixel(long x, long y)
{
	if (chainstat)
	{
		koutpw(0x3ce,4+((x&3)<<8));
		return(readpixel(ylookup[y]+(x>>2)+chainplace));
	}
	else
	{
		return(readpixel(ylookup[y]+x+frameplace));
	}
}

clearscreen(char dacol)
{
	long i, totbytes, col;

	col = ((long)dacol) + (((long)dacol)<<8); col += (col<<16);
	if (chainstat)
	{
		outpw(0x3c4,0x0f02);
		clearbuf(chainplace,(xdim*ydim)>>4,0L); //clear frame first
		faketimerhandler();
	}
	else
	{
		clearbufbyte(frameplace,imageSize,col);
		faketimerhandler();
	}
}

rotatepoint(long xpivot, long ypivot, long x, long y, short daang, long *x2, long *y2)
{
	long dacos, dasin;

	dacos = sintable[(daang+2560)&2047];
	dasin = sintable[(daang+2048)&2047];
	x -= xpivot;
	y -= ypivot;
	*x2 = dmulscale14(x,dacos,-y,dasin) + xpivot;
	*y2 = dmulscale14(y,dacos,x,dasin) + ypivot;
}

setxmode(long daxdim, long daydim)
{
	long vlinum;

	koutp(0x3d4,0x11); koutp(0x3d5,(kinp(0x3d5)&0x7f));
	koutpw(0x03d4,0x0014);
	koutpw(0x03d4,0xe317);
	koutpw(0x03c4,0x0604);

	switch(xdim)
	{
		case 256:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0xf3)|0x00));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x5f00);
			koutpw(0x03d4,0x8203);
			koutpw(0x03d4,0x4e04);
			koutpw(0x03d4,0x9605);
			break;
		case 320:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0xf3)|0x00));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x5f00);
			koutpw(0x03d4,0x8203);
			koutpw(0x03d4,0x5404);
			koutpw(0x03d4,0x8005);
			break;
		case 360:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0xf3)|0x04));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x6b00);
			koutpw(0x03d4,0x8e03);
			koutpw(0x03d4,0x5e04);
			koutpw(0x03d4,0x8a05);
			break;
		case 400:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0xf3)|0x04));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x7100 + 0x300);   //Add 0x300 for Ken's ViewSonic17
			koutpw(0x03d4,0x9203);
			koutpw(0x03d4,0x6504);
			koutpw(0x03d4,0x6c04);
			koutpw(0x03d4,0x8205 - 0x100);   //Sub 0x100 for Ken's ViewSonic17
			break;
		default: return(-1);
	}
	koutpw(0x03d4,(((xdim>>2)-1)<<8)+0x1);
	koutpw(0x03d4,((xdim>>2)<<8)+0x2);
	koutpw(0x03d4,((xdim>>3)<<8)+0x13);

	switch(ydim)
	{
		case 300:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0x80));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x4606);
			koutpw(0x03d4,0x1f07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0x3110);
			koutpw(0x03d4,0x8011);
			koutpw(0x03d4,0x2b12);
			koutpw(0x03d4,0x2f15);
			koutpw(0x03d4,0x4416);
			break;
		case 350:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0x80));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x7c06);
			koutpw(0x03d4,0x1f07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0x6210);
			koutpw(0x03d4,0x8011);
			koutpw(0x03d4,0x5d12);
			koutpw(0x03d4,0x5d15);
			koutpw(0x03d4,0x7a16);
			break;
		case 360:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0x40));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0xbf06);
			koutpw(0x03d4,0x1f07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0x8810);
			koutpw(0x03d4,0x8511);
			koutpw(0x03d4,0x6712);
			koutpw(0x03d4,0x6d15);
			koutpw(0x03d4,0xba16);
			break;
		case 400: case 200:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0x40));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0xbf06);
			koutpw(0x03d4,0x1f07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0x9c10);
			koutpw(0x03d4,0x8e11);
			koutpw(0x03d4,0x8f12);
			koutpw(0x03d4,0x9615);
			koutpw(0x03d4,0xb916);
			break;
		case 480: case 240:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0xc0));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x0d06);
			koutpw(0x03d4,0x3e07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0xea10);
			koutpw(0x03d4,0xac11);
			koutpw(0x03d4,0xdf12);
			koutpw(0x03d4,0xe715);
			koutpw(0x03d4,0x0616);
			break;
		case 512: case 256:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0xc0));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x2306);
			koutpw(0x03d4,0xb207);
			koutpw(0x03d4,0x6009);
			koutpw(0x03d4,0x0a10);
			koutpw(0x03d4,0xac11);
			koutpw(0x03d4,0xff12);
			koutpw(0x03d4,0x0715);
			koutpw(0x03d4,0x1a16);
			break;
		case 540: case 270:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0xc0));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x3006);
			koutpw(0x03d4,0xf007);
			koutpw(0x03d4,0x6009);
			koutpw(0x03d4,0x2010);
			koutpw(0x03d4,0xa911);
			koutpw(0x03d4,0x1b12);
			koutpw(0x03d4,0x1f15);
			koutpw(0x03d4,0x2f16);
			break;
	}
	switch(ydim)
	{
		case 200: case 240: case 256: case 270:
			vlinum = 1; break;
		case 300: case 350: case 360: case 400: case 480: case 512: case 540:
			vlinum = 0; break;
	}
	koutp(0x3d4,0x09); koutp(0x3d5,((kinp(0x3d5)&0x00e0)|(vlinum&0x001f)));
	return(0);
}
