#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <string.h>
#include <dos.h>
#include "2draw.h"
#include "names.h"
#include "pragmas.h"

#define TIMERINTSPERSECOND 280
#define MOVESPERSECOND 40
#define TICSPERFRAME 3
#define MOVEFIFOSIZ 256
#define TIMERUPDATESIZ 32

//Status list 0: Power-ups
//Status list 1: Monsters
//Status list 2: Bullets
//Status list 3: Explosions

void (__interrupt __far *oldtimerhandler)();
void __interrupt __far timerhandler(void);

	//Player variables
static long posx[MAXPLAYERS], posy[MAXPLAYERS], zoom[MAXPLAYERS];
static short ang[MAXPLAYERS], vel[MAXPLAYERS], svel[MAXPLAYERS];
static short angvel[MAXPLAYERS], zoomvel[MAXPLAYERS];
static long lastshoottime[MAXPLAYERS], health[MAXPLAYERS];
static long deadspinx[MAXPLAYERS], deadspiny[MAXPLAYERS];
static char prepboardflag[MAXPLAYERS];

static long myminlag[MAXPLAYERS], mymaxlag, otherminlag, bufferjitter = 1;

static long fakemovefifoplc;
static long myx, myy, myzoom, omyx, omyy, omyzoom;
static short myang, omyang, myvel, mysvel, myangvel, myzoomvel;
static long myxbak[MOVEFIFOSIZ], myybak[MOVEFIFOSIZ], myzoombak[MOVEFIFOSIZ];
static short myangbak[MOVEFIFOSIZ];

#define NUMOPTIONS 8
#define NUMKEYS 19
static long chainxres[4] = {256,320,360,400};
static long chainyres[11] = {200,240,256,270,300,350,360,400,480,512,540};
static long vesares[13][2] = {320,200,360,200,320,240,360,240,320,400,
									360,400,640,350,640,400,640,480,800,600,
									1024,768,1280,1024,1600,1200};
static char option[NUMOPTIONS] = {0,0,0,0,0,0,1,0};
static char keys[NUMKEYS] =
{
	0xc8,0xd0,0xcb,0xcd,0x2a,0x9d,0x1d,0x39,
	0x1e,0x2c,0xd1,0xc9,0x47,0x49,
	0x9c,0x1c,0xd,0xc,0xf,
};

static long digihz[7] = {6000,8000,11025,16000,22050,32000,44100};

static long lockclock = 0, ototalclock = 0;
static long ready2send = 0;
static long oposx[MAXPLAYERS], oposy[MAXPLAYERS], ozoom[MAXPLAYERS];
static short oang[MAXPLAYERS];

static long cposx[MAXPLAYERS], cposy[MAXPLAYERS], czoom[MAXPLAYERS];
static short cang[MAXPLAYERS];

static long ospritex[MAXSPRITES];
static long ospritey[MAXSPRITES];
static long ospritezoom[MAXSPRITES];
static short ospriteang[MAXSPRITES];

static char palette[768], boardfilename[13], moustat = 0;
static short boardnum = 0;

	//Sprite variables
typedef struct
{
	long vel, time;
	short angvel, owner, health;
} spritetype;
spritetype sprite[MAXSPRITES];

static char packbuf[546];
static char tempbuf[546];
static short screenpeek = 0;
static long masterslavetexttime;

	//ENGINE CONTROLLED MULTIPLAYER VARIABLES:
extern short numplayers, myconnectindex;
extern short connecthead, connectpoint2[MAXPLAYERS];   //Player linked list variables (indeces, not connection numbers)
static char playerreadyflag[MAXPLAYERS], playerquitflag[MAXPLAYERS];

typedef struct
{
	signed char mousx, mousy;
	short bits;
} input;

	//Local syncing variables
static char networkmode = 255;     //0 is 2(n-1) mode, 1 is n(n-1) mode
static char movesperpacket = 1;
static char rewire = 0;

	//Send/Receiving syncing variables
static long movefifoplc, movefifosendplc, movefifoend[MAXPLAYERS];
static input inputfifo[MOVEFIFOSIZ][MAXPLAYERS], loc;
static long avgmousx = 0, avgmousy = 0, avgbits = 0;

	//Record/Playback variables
static long reccnt, recfil = -1, recstat = 0;
#define RECBUFSIZ 1024
static input recbuf[RECBUFSIZ];

	//GAME.C sync state variables
static char syncstat, syncval[MAXPLAYERS][MOVEFIFOSIZ];
static long syncvalhead[MAXPLAYERS], syncvaltail, syncvaltottail;

#define RECSNDSIZ 65536
extern long recsndoffs, recsnddone, precsndoffs;
static long recording = -2, precording = 0;
static long rectotalclock, recleng;

	//Variables that let you type messages to other player
static char getmessage[162], getmessageleng;
static long getmessagetimeoff;
static char typemessage[162], typemessageleng = 0, typemode = 0;
static char scantoasc[128] =
{
	0,0,'1','2','3','4','5','6','7','8','9','0','-','=',0,0,
	'q','w','e','r','t','y','u','i','o','p','[',']',0,0,'a','s',
	'd','f','g','h','j','k','l',';',39,'`',0,92,'z','x','c','v',
	'b','n','m',',','.','/',0,'*',0,32,0,0,0,0,0,0,
	0,0,0,0,0,0,0,'7','8','9','-','4','5','6','+','1',
	'2','3','0','.',0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};
static char scantoascwithshift[128] =
{
	0,0,'!','@','#','$','%','^','&','*','(',')','_','+',0,0,
	'Q','W','E','R','T','Y','U','I','O','P','{','}',0,0,'A','S',
	'D','F','G','H','J','K','L',':',34,'~',0,'|','Z','X','C','V',
	'B','N','M','<','>','?',0,'*',0,32,0,0,0,0,0,0,
	0,0,0,0,0,0,0,'7','8','9','-','4','5','6','+','1',
	'2','3','0','.',0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};

main(long argc, char **argv)
{
	long i, j, fil;
	char *ptr;

	strcpy(&boardfilename,"boards.map");
	for(i=1;i<argc;i++)
	{
		if ((!stricmp("-net",argv[i])) || (!stricmp("/net",argv[i])))
			{ i++; continue; }

		if ((argv[i][0] == '-') || (argv[i][0] == '/'))
		{
			switch(argv[i][1])
			{
				case 'N': case 'n': case 'I': case 'i':
					if (argv[i][2] == '0') networkmode = 0;
					if (argv[i][2] == '1') networkmode = 1;
					break;
				case 'F': case 'f':
					if (argv[i][2] == '1') movesperpacket = 1;
					if (argv[i][2] == '2') movesperpacket = 2;
					if (argv[i][2] == '4') movesperpacket = 4;
					if (argv[i][2] == '8') movesperpacket = 8;
					break;
				case 'R': case 'r':
					recstat = 1;
					break;
				case 'C': case 'c':
					rewire = argv[i][2]-48;
					if (rewire >= MAXPLAYERS) rewire = 0;
					break;
			}
		}
		else
		{
			strcpy(&boardfilename,argv[i]);
			if (!strchr(boardfilename,'.')) strcat(boardfilename,".map");
		}
	}

	initgroupfile("stuff.dat");

	if ((fil = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&option[0],NUMOPTIONS);
		read(fil,&keys[0],NUMKEYS);
		close(fil);
	}
	if (option[3] != 0) moustat = initmouse();

	switch(option[0])
	{
		case 0: init2draw(0,chainxres[option[6]&15],chainyres[option[6]>>4]); break;
		case 1: init2draw(1,vesares[option[6]&15][0],vesares[option[6]&15][1]); break;
		default: init2draw(option[0],320L,200L); break;
	}
	inittimer();

	initmultiplayers(option[4],option[5],0);
	setpackettimeout((TIMERINTSPERSECOND/MOVESPERSECOND)*movesperpacket*8,(TIMERINTSPERSECOND/MOVESPERSECOND)*movesperpacket);

		//Re-wire connect list
	if (rewire > 0)
	{
		j = connecthead;
		for(i=0;i<rewire;i++) j = connectpoint2[j];
		if (j >= 0)
		{
			connectpoint2[connecthead] = connectpoint2[j];
			connectpoint2[j] = connecthead;
			connecthead = j;
		}
	}

	if (recstat)
	{
		if ((recfil = open("demo.rec",O_BINARY|O_CREAT|O_RDWR,S_IREAD|S_IWRITE)) == -1)
			recstat = 0;
		else
		{
			reccnt = 0;
			recstat = 1;
			write(recfil,&reccnt,4);
			write(recfil,&numplayers,2);
			write(recfil,&myconnectindex,2);
			write(recfil,&connecthead,2);
			write(recfil,connectpoint2,sizeof(connectpoint2));
		}
	}

	loadpics("tiles000.art");

	initsb(option[1],option[2],digihz[option[7]>>4],((option[7]&4)>0)+1,((option[7]&2)>0)+1,60,option[7]&1);
	loadsong("flysong.kdm");
	musicon();

	loadpalette("palette.dat");
	setviewboundaries();
	permanentwritesprite(0,0,STATUSBAR);

	for(i=0;i<MAXPLAYERS;i++) prepboardflag[i] = 0;

	prepareboard(boardfilename,boardnum);

	/*if (option[4] > 0)
	{
		sendlogon();
		if (option[4] < 5) waitplayers = 2; else waitplayers = option[4]-3;
		while (numplayers < waitplayers)
		{
			sprintf(tempbuf,"%ld of %ld players in...",numplayers,waitplayers);
			printext256(68L,84L,31,0,tempbuf,0);

			if (getpacket(&other,tempbuf) > 0)
				if (tempbuf[0] == 255) cleanexit();

			if (keystatus[1] > 0) cleanexit();
		}
	}*/
	screenpeek = myconnectindex;

	if (networkmode == 255)
	{
		if ((numplayers >= 2) && (numplayers <= 4))
			networkmode = 1;
		else
			networkmode = 0;
	}

	allocateprec(RECSNDSIZ);

	ready2send = 1;
	while ((ready2send == 1) && (keystatus[0x46] == 0))       //Main loop starts here
	{
		//if (keystatus[0x18]) posx[0] += 16;   //'o' - OOS key!

		if (option[1] == 1)  //Keypad '0' to record (R conflicts with playback)
		{
			if ((keystatus[0x52] > 0) && (recsnddone == 1) && (recording == -2))      //R (record)
			{
				wrec(RECSNDSIZ);
				recording = -1;
			}
			if ((recording == -1) && ((keystatus[0x52] == 0) || (recsnddone == 1)))
			{
				continueplay();
				recsnddone = 1;
				recording = 0;
				rectotalclock = totalclock;
				if (numplayers < 2) wsay("recordedvoice",2972L,255L,255L);

				ptr = (char *)(recsndoffs);
				for(recleng=RECSNDSIZ-1;recleng>0;recleng--)
					if (ptr[recleng] != 128) break;
			}
			if ((recording >= 0) && (numplayers >= 2))
			{
				if (totalclock >= rectotalclock)
				{
					rectotalclock += 16;

					ptr = (char *)(recsndoffs+recording);

					packbuf[0] = 3;
					for(i=0;i<512;i++) packbuf[i+1] = ptr[i];

					for(i=connecthead;i>=0;i=connectpoint2[i])
						if (i != myconnectindex)
							sendpacket(i,packbuf,513L);

					recording += 512;
					if (recording >= recleng)
					{
						recording = -2;

						packbuf[0] = 4;
						for(i=connecthead;i>=0;i=connectpoint2[i])
							if (i != myconnectindex)
								sendpacket(i,packbuf,1);
					}
				}
			}
		}

		moveloop();
		drawscreen(screenpeek,(totalclock-ototalclock)*(65536/(TIMERINTSPERSECOND/MOVESPERSECOND)));
	}
	cleanexit();
}

cleanexit()
{
	long i, j, oldtotalclock;

	ready2send = 0;

	if (recstat != 0)
	{
		recstat = 0;
		if (reccnt&(RECBUFSIZ-1))
			write(recfil,recbuf,(reccnt&(RECBUFSIZ-1))*sizeof(input));
		lseek(recfil,0L,SEEK_SET);
		write(recfil,&reccnt,4);
		close(recfil);
	}

	for(j=0;j<8;j++)
	{
		oldtotalclock = totalclock;
		while (totalclock < oldtotalclock+TICSPERFRAME)
			getpackets();

		packbuf[0] = 127;
		for(i=connecthead;i>=0;i=connectpoint2[i])
			if (i != myconnectindex)
				sendpacket(i,packbuf,1);
	}

	musicoff();
	uninitsb();
	uninitmultiplayers();
	uninittimer();
	uninit2draw();
	uninitgroupfile();
	exit(0);
}

moveloop()
{
	long i;

	if (numplayers > 1)
		while (fakemovefifoplc < movefifoend[myconnectindex]) fakedomovethings();

	getpackets();
	if (numplayers < 2) bufferjitter = 0;
	while (movefifoend[myconnectindex]-movefifoplc > bufferjitter)
	{
		for(i=connecthead;i>=0;i=connectpoint2[i])
			if (movefifoplc == movefifoend[i]) break;
		if (i >= 0) break;
		domovethings();
	}
}

drawscreen(short snum, long smoothratio)
{
	long i, j, xvect, yvect, charsperline, templong, x, y, z, a;

	smoothratio = min(max(smoothratio,0),65536);

	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		cposx[i] = oposx[i]+mulscale16(posx[i]-oposx[i],smoothratio);
		cposy[i] = oposy[i]+mulscale16(posy[i]-oposy[i],smoothratio);
		czoom[i] = ozoom[i]+mulscale16(zoom[i]-ozoom[i],smoothratio);
		cang[i] = oang[i]+mulscale16(((ang[i]+1024-oang[i])&2047)-1024,smoothratio);
	}
	if (numplayers > 1)
	{
		cposx[myconnectindex] = omyx+mulscale16(myx-omyx,smoothratio);
		cposy[myconnectindex] = omyy+mulscale16(myy-omyy,smoothratio);
		czoom[myconnectindex] = omyzoom+mulscale16(myzoom-omyzoom,smoothratio);
		cang[myconnectindex] = omyang+mulscale16((long)(((myang+1024-omyang)&2047)-1024),smoothratio);
	}

	setears(cposx[snum],cposy[snum],(long)sintable[cang[snum]&2047],(long)sintable[(cang[snum]+1536)&2047]);

			//Draw the full 2-D board
	draw2board(cposx[snum],cposy[snum],czoom[snum],cang[snum]);

		//Draw power-ups
	for(i=headsprite[0];i>=0;i=nextsprite[i])
	{
		a = spriteang[i]-sprite[i].angvel;
		a += mulscale16(((spriteang[i]+1024-a)&2047)-1024,smoothratio);
		drawsprite(spritex[i],spritey[i],spritezoom[i],a,spritepicnum[i],255);
	}

		//Draw bullets
	for(i=headsprite[2];i>=0;i=nextsprite[i])
	{
		x = ospritex[i]+mulscale16(spritex[i]-ospritex[i],smoothratio);
		y = ospritey[i]+mulscale16(spritey[i]-ospritey[i],smoothratio);
		z = ospritezoom[i]+mulscale16(spritezoom[i]-ospritezoom[i],smoothratio);
		a = ospriteang[i]+mulscale16(((spriteang[i]+1024-ospriteang[i])&2047)-1024,smoothratio);
		drawsprite(x,y,z,a,spritepicnum[i],255);
	}

		//Draw monsters
	for(i=headsprite[1];i>=0;i=nextsprite[i])
	{
		x = ospritex[i]+mulscale16(spritex[i]-ospritex[i],smoothratio);
		y = ospritey[i]+mulscale16(spritey[i]-ospritey[i],smoothratio);
		z = ospritezoom[i]+mulscale16(spritezoom[i]-ospritezoom[i],smoothratio);
		a = ospriteang[i]+mulscale16(((spriteang[i]+1024-ospriteang[i])&2047)-1024,smoothratio);

		if (sprite[i].time < totalclock)
			drawsprite(x,y,z,a,spritepicnum[i],255);
		else  //Sprite flash bright pink
			drawsprite(x,y,z,a,spritepicnum[i],254);
	}

		//Draw players
	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		if (health[i] >= 0)
		{
			if ((health[i] >= 4096) || ((totalclock&48) != 0))
				drawsprite(cposx[i],cposy[i],65536,cang[i],AIRPLANE,255);
			else  //Sprite flash red if you're practically dead (it rhymes!)
				drawsprite(cposx[i],cposy[i],65536,cang[i],AIRPLANE,159);
		}
		else
			drawsprite(deadspinx[i],deadspiny[i],65536+(health[i]<<8),ang[i]+(health[i]<<3),BURNINGAIRPLANE,255);
	}

	for(i=headsprite[3];i>=0;i=nextsprite[i])          //Draw explosions over it
	{
		x = ospritex[i]+mulscale16(spritex[i]-ospritex[i],smoothratio);
		y = ospritey[i]+mulscale16(spritey[i]-ospritey[i],smoothratio);
		z = ospritezoom[i]+mulscale16(spritezoom[i]-ospritezoom[i],smoothratio);
		a = ospriteang[i]+mulscale16(((spriteang[i]+1024-ospriteang[i])&2047)-1024,smoothratio);

		drawsprite(x,y,z,a,spritepicnum[i],255);
	}

		//Tell who's master or slave
	if (lockclock < masterslavetexttime+TIMERINTSPERSECOND)
	{
		if (numplayers < 2)
			printext256(152L,92L,31,-1,"Alone",0);
		else
		{
			if (networkmode == 0)
			{
				if (myconnectindex == connecthead)
					printext256(152L,92L,31,-1,"Master",0);
				else
					printext256(152L,92L,31,-1,"Slave",0);
			}
			else
				printext256(152L,92L,31,-1,"Even",0);
		}
	}

	if (typemode == 1)
	{
		charsperline = 36;

		for(i=0;i<=typemessageleng;i+=charsperline)
		{
			for(j=0;j<charsperline;j++)
				tempbuf[j] = typemessage[i+j];
			if (typemessageleng < i+charsperline)
			{
				tempbuf[(typemessageleng-i)] = '_';
				tempbuf[(typemessageleng-i)+1] = 0;
			}
			else
				tempbuf[charsperline] = 0;
			printext256(32L,(i/charsperline)<<3,191,-1,tempbuf,0);
		}
	}
	if (getmessageleng > 0)
	{
		charsperline = 36;

		for(i=0;i<=getmessageleng;i+=charsperline)
		{
			for(j=0;j<charsperline;j++)
				tempbuf[j] = getmessage[i+j];
			if (getmessageleng < i+charsperline)
				tempbuf[(getmessageleng-i)] = 0;
			else
				tempbuf[charsperline] = 0;

			printext256(32L,((i/charsperline)<<3)+(ydim-8)-(((getmessageleng-1)/charsperline)<<3),159,-1,tempbuf,0);
		}
		if (totalclock > getmessagetimeoff)
			getmessageleng = 0;
	}

	if (keystatus[88] > 0)   //F12
	{
		keystatus[88] = 0;
		screencapture();
	}

	for(i=connecthead;i>=0;i=connectpoint2[i])
		if (syncvalhead[i] == syncvaltottail) break;
	if (i < 0)
	{
		syncstat = 0;
		do
		{
			for(i=connectpoint2[connecthead];i>=0;i=connectpoint2[i])
				if (syncval[i][syncvaltottail&(MOVEFIFOSIZ-1)] != syncval[connecthead][syncvaltottail&(MOVEFIFOSIZ-1)])
					syncstat = 1;
			syncvaltottail++;
			for(i=connecthead;i>=0;i=connectpoint2[i])
				if (syncvalhead[i] == syncvaltottail) break;
		} while (i < 0);
	}
	if (connectpoint2[connecthead] < 0) syncstat = 0;
	if (syncstat != 0) printext256(68L,84L,31,0,"OUT OF SYNC!",0);

	nextpage();
}

getinput(input *syn)
{
	long i;
	short mousx, mousy, bstatus;

	if (option[3] != 0)
		getmousevalues(&mousx,&mousy,&bstatus);
	else
		{ mousx = 0; mousy = 0; bstatus = 0; }

	syn[0].mousx = (signed char)max(min(mousx,127),-128);
	syn[0].mousy = (signed char)max(min(mousy,127),-128);
	syn[0].bits = 0;

	if (typemode == 0)
	{
		if (keystatus[keys[15]] > 0)  //Left ENTER
		{
			keystatus[keys[15]] = 0;
			screenpeek = connectpoint2[screenpeek];
			if (screenpeek < 0) screenpeek = connecthead;
		}

		if ((keystatus[0x13]&keystatus[keys[4]]) > 0)   //Sh.Sh.R (replay)
		{
			keystatus[0x13] = 0;
			if (recstat != 0)
			{
				recstat = 0;
				if (reccnt&(RECBUFSIZ-1))
					write(recfil,recbuf,(reccnt&(RECBUFSIZ-1))*sizeof(input));
				lseek(recfil,0L,SEEK_SET);
				write(recfil,&reccnt,4);
				close(recfil);
			}
			playback();
			keystatus[1] = 1;
		}

		syn[0].bits = ((bstatus&1)<<15) + (((bstatus&6)>0)<<14);
		syn[0].bits += (keystatus[0x32]<<13);  //M (be master)
		syn[0].bits += (keystatus[keys[7]]<<12);
		syn[0].bits += (keystatus[0xd1]<<11) + (keystatus[0xc9]<<10);
		syn[0].bits += (keystatus[keys[6]]<<9) + (keystatus[keys[5]]<<8);
		syn[0].bits += (keystatus[keys[4]]<<7) + (keystatus[keys[9]]<<6);
		syn[0].bits += (keystatus[keys[8]]<<5) + (keystatus[keys[3]]<<4);
		syn[0].bits += (keystatus[keys[2]]<<3) + (keystatus[keys[1]]<<2);
		syn[0].bits += (keystatus[keys[0]]<<1) + keystatus[0x1];
	}
}

void fakedomovethings(void)
{
	input *syn;
	long i, j, k, x, y, doubvel, xvect, yvect, goalz;
	short movez, mousx, mousy, mstrafe;

	syn = (input *)&inputfifo[fakemovefifoplc&(MOVEFIFOSIZ-1)][myconnectindex];

	omyx = myx;
	omyy = myy;
	omyzoom = myzoom;
	omyang = myang;

	mousx = syn->mousx;
	mousy = (((short)syn->mousy)<<3);
	mstrafe = 0;

	if (((syn->bits&256) > 0) || ((syn->bits&16384) != 0))   //Rt. Ctrl or Rt. mouse button
	{
		mstrafe = (mousx<<3);
		mousx = 0;
		if ((syn->bits&8) > 0) mstrafe -= (TICSPERFRAME<<(4+((syn->bits&128)>0)));
		if ((syn->bits&16) > 0) mstrafe += (TICSPERFRAME<<(4+((syn->bits&128)>0)));
	}
	else                       //Else turn
	{
		if ((syn->bits&8) > 0) mousx -= (TICSPERFRAME<<(2+((syn->bits&128)>0)));
		if ((syn->bits&16) > 0) mousx += (TICSPERFRAME<<(2+((syn->bits&128)>0)));
	}                          //Move forward / backward
	if ((syn->bits&2) > 0) mousy -= (TICSPERFRAME<<(4+((syn->bits&128)>0)));
	if ((syn->bits&4) > 0) mousy += (TICSPERFRAME<<(4+((syn->bits&128)>0)));

	i = myangvel;
	myangvel = ((myangvel*3+mousx)>>2);
	if (i == myangvel)
	{
		if (mousx < myangvel) myangvel--;
		if (mousx > myangvel) myangvel++;
	}
	i = myvel;
	myvel = ((i*3+mousy)>>2);
	if (i == myvel)
	{
		if (mousy < myvel) myvel--;
		if (mousy > myvel) myvel++;
	}
	i = mysvel;
	mysvel = ((i*3+mstrafe)>>2);
	if (i == mysvel)
	{
		if (mstrafe < mysvel) mysvel--;
		if (mstrafe > mysvel) mysvel++;
	}

	myang = ((myang+myangvel)&2047);
	xvect = (((long)sintable[(-myang)&2047])*((long)myvel));
	yvect = (((long)sintable[(2560-myang)&2047])*((long)myvel));
	xvect += (((long)sintable[(2560-myang)&2047])*((long)mysvel));
	yvect += (((long)sintable[(1024-myang)&2047])*((long)mysvel));
	clipmove(&myx,&myy,xvect,yvect,2097152,1);   //Actually move player!

	movez = 0;
	if ((syn->bits&32) > 0) movez -= (TICSPERFRAME<<(7+(((syn->bits&128)>0)<<1)));
	if ((syn->bits&64) > 0) movez += (TICSPERFRAME<<(7+(((syn->bits&128)>0)<<1)));

	i = myzoomvel;
	myzoomvel = ((i*3+movez)>>2);
	if (i == myzoomvel)
	{
		if (movez < myzoomvel) myzoomvel--;
		if (movez > myzoomvel) myzoomvel++;
	}
	myzoom += myzoomvel;
	if (myzoom < 16384) myzoom = 16384;
	if (myzoom > 1048576) myzoom = 1048576;

	myxbak[fakemovefifoplc&(MOVEFIFOSIZ-1)] = myx;
	myybak[fakemovefifoplc&(MOVEFIFOSIZ-1)] = myy;
	myzoombak[fakemovefifoplc&(MOVEFIFOSIZ-1)] = myzoom;
	myangbak[fakemovefifoplc&(MOVEFIFOSIZ-1)] = myang;
	fakemovefifoplc++;
}

	//Prediction correction
fakedomovethingscorrect()
{
	long i;

	if (numplayers < 2) return;

	i = ((movefifoplc-1)&(MOVEFIFOSIZ-1));

	if ((posx[myconnectindex] == myxbak[i]) &&
		 (posy[myconnectindex] == myybak[i]) &&
		 (zoom[myconnectindex] == myzoombak[i]) &&
		 (ang[myconnectindex] == myangbak[i]))
		 return;

		//Re-start fakedomovethings back to place of error
	myx = omyx = posx[myconnectindex];
	myy = omyy = posy[myconnectindex];
	myzoom = omyzoom = zoom[myconnectindex];
	myang = omyang = ang[myconnectindex];
	myvel = vel[myconnectindex];
	mysvel = svel[myconnectindex];
	myzoomvel = zoomvel[myconnectindex];
	myangvel = angvel[myconnectindex];

	fakemovefifoplc = movefifoplc;
	while (fakemovefifoplc < movefifoend[myconnectindex]) fakedomovethings();
}

domovethings()
{
	long x, y, i, j, k, l, nexti, nextj;
	long dist1, dist2, mindist, xvect, yvect;
	short daang, dapic;
	char ch;
	input *syn;

	syn = (input *)&inputfifo[movefifoplc&(MOVEFIFOSIZ-1)][0];
	movefifoplc++;

	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		if ((syn[i].bits&1) == 0) { j = i; continue; }
		if (i == myconnectindex) { ready2send = 0; return; }
		if (screenpeek == i)
		{
			screenpeek = connectpoint2[i];
			if (screenpeek < 0) screenpeek = connecthead;
		}
		if (i == connecthead) connecthead = connectpoint2[connecthead];
							  else connectpoint2[j] = connectpoint2[i];
		numplayers--;

		sprintf(getmessage,"Player %ld is history!",i+1);
		getmessageleng = strlen(getmessage);
		getmessagetimeoff = totalclock+360+(getmessageleng<<4);
	}

	if ((numplayers >= 2) && ((movefifoplc&7) == 7))
	{
		ch = (char)(randomseed&255);
		for(i=connecthead;i>=0;i=connectpoint2[i])
			ch += ((posx[i]+posy[i]+zoom[i]+ang[i])&255);
		syncval[myconnectindex][syncvalhead[myconnectindex]&(MOVEFIFOSIZ-1)] = ch;
		syncvalhead[myconnectindex]++;
	}

	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		oposx[i] = posx[i];
		oposy[i] = posy[i];
		ozoom[i] = zoom[i];
		oang[i] = ang[i];
	}

	if (recstat != 0)
	{
		for(i=connecthead;i>=0;i=connectpoint2[i])
		{
			copybufbyte(&syn[i],&recbuf[reccnt&(RECBUFSIZ-1)],sizeof(input));
			reccnt++;
			if (!(reccnt&(RECBUFSIZ-1))) write(recfil,recbuf,sizeof(recbuf));
		}
	}

	lockclock += TICSPERFRAME;

		//Go through power-up sprites
	i = headsprite[0];
	while (i != -1)
	{
		nexti = nextsprite[i];

		spriteang[i] = ((spriteang[i]+sprite[i].angvel)&2047);

		for(k=connecthead;k>=0;k=connectpoint2[k])
			if (klabs(spritex[i]-posx[k]) < 6291456)
				if (klabs(spritey[i]-posy[k]) < 6291456)
				{
					switch(spritepicnum[i])
					{
						case COIN:
							wsayfollow("getstuff.wav",4096L,256L,&spritex[i],&spritey[i],0);
							health[k] += 1024;
							break;
						case SUPERSPIRAL:
							wsayfollow("spiral.wav",4096L,256L,&spritex[i],&spritey[i],0);
							explode((short)i,8,SUPERSPIRALGET);
							health[k] += 4096;
							break;
					}
					deletesprite(i);
					goto nextsprite0;
				}

nextsprite0:
		i = nexti;
	}

		//Go through monster sprites
	i = headsprite[1];
	while (i != -1)
	{
		nexti = nextsprite[i];            //Back up pointer to next sprite

		ospritex[i] = spritex[i];
		ospritey[i] = spritey[i];
		ospriteang[i] = spriteang[i];
		ospritezoom[i] = spritezoom[i];

			//Move monster synctics steps
		j = sprite[i].vel*TICSPERFRAME;
		xvect = ((j*sintable[spriteang[i]])>>2);
		yvect = ((-j*sintable[(spriteang[i]+512)&2047])>>2);
		clipmove(&spritex[i],&spritey[i],xvect,yvect,2097152,1);
		spriteang[i] = ((spriteang[i]+sprite[i].angvel)&2047);

		dapic = spritepicnum[i];
		if ((dapic == AIRPLANE) || (dapic == CAR) || (dapic == CAR2))
		{
				//k = which player to attack
			mindist = 0x7fffffff; k = connecthead;
			for(j=connecthead;j>=0;j=connectpoint2[j])
			{
				dist1 = (posx[j]>>16)-(spritex[i]>>16); dist1 *= dist1;
				dist2 = (posy[j]>>16)-(spritey[i]>>16); dist2 *= dist2;
				if ((dist1+dist2) < mindist) mindist = (dist1+dist2), k = j;
			}

			if (dapic == AIRPLANE)
				if (mindist < (8<<18))
				{
					daang = ((getangle((posx[k]>>8)-(spritex[i]>>8),(posy[k]>>8)-(spritey[i]>>8))+512)&2047);
					if (((spriteang[i]-daang)&2047) < 1024)
						sprite[i].angvel = -(((spriteang[i]-daang)&2047)>>4);
					else
						sprite[i].angvel = (((daang-spriteang[i])&2047)>>4);
						//Enemy airplane randomly shoots a bullet
					if ((((spriteang[i]-daang)&2047) < 128) || (((daang-spriteang[i])&2047) < 128))
						if ((krand()&31) < TICSPERFRAME)
							if (canmovethrough(posx[k],posy[k],spritex[i],spritey[i],2) == 1)
								shootbullet((short)i);
				}
			if (dapic == CAR)
				if (mindist < (32<<18))
				{
					daang = ((getangle((posx[k]>>8)-(spritex[i]>>8),(posy[k]>>8)-(spritey[i]>>8))+512)&2047);
					if (((spriteang[i]-daang)&2047) < 1024)
						sprite[i].angvel = -(((spriteang[i]-daang)&2047)>>6);
					else
						sprite[i].angvel = (((daang-spriteang[i])&2047)>>6);
					//Enemy car randomly shoots a bullet
					if ((((spriteang[i]-daang)&2047) < 128) || (((daang-spriteang[i])&2047) < 128))
						if ((krand()&63) < TICSPERFRAME)   //Enemy car randomly shoots a bullet
							if (canmovethrough(posx[k],posy[k],spritex[i],spritey[i],2) == 1)
								shootbullet((short)i);
				}
			if (dapic == CAR2)
				if (mindist < (32<<18))
				{
					daang = ((getangle((posx[k]>>8)-(spritex[i]>>8),(posy[k]>>8)-(spritey[i]>>8))+512)&2047);
					if (((spriteang[i]-daang)&2047) < 1024)
						sprite[i].angvel = -(((spriteang[i]-daang)&2047)>>7);
					else
						sprite[i].angvel = (((daang-spriteang[i])&2047)>>7);
					//Enemy car randomly shoots a bullet
					if ((((spriteang[i]-daang)&2047) < 256) || (((daang-spriteang[i])&2047) < 256))
						if ((krand()&255) < TICSPERFRAME)   //Enemy car randomly shoots a bullet
							if (canmovethrough(posx[k],posy[k],spritex[i],spritey[i],2) == 1)
								shootbullet((short)i);
				}
		}

		if ((dapic == BROKENCAR) || (dapic == BROKENCAR2))
		{                    //Broken car slows down then shrinks
			if (sprite[i].vel > 0) sprite[i].vel = max(sprite[i].vel-(TICSPERFRAME>>1)-1,0);
			if (sprite[i].vel < 0) sprite[i].vel = min(sprite[i].vel+(TICSPERFRAME>>1)+1,0);
			if (sprite[i].vel == 0) spritezoom[i] -= (TICSPERFRAME<<9);
			if (spritezoom[i] <= 0)
			{                //When car shrinks to nothing, delete it
				deletesprite(i);
				goto nextsprite1;
			}
		}
nextsprite1:
		i = nexti;
	}

		//Go through bullet sprites...
	i = headsprite[2];
	while (i != -1)
	{
		nexti = nextsprite[i];            //Back up pointer to next sprite

		ospritex[i] = spritex[i];
		ospritey[i] = spritey[i];
		ospriteang[i] = spriteang[i];
		ospritezoom[i] = spritezoom[i];

			//Bullet gets deleted after 8 seconds of life
		if (lockclock > sprite[i].time+(TIMERINTSPERSECOND<<3))
		{
			deletesprite(i);
			goto nextsprite2;
		}

			//Move bullet synctics steps
		j = sprite[i].vel*TICSPERFRAME;
		xvect = ((j*sintable[spriteang[i]])>>2);
		yvect = ((-j*sintable[(spriteang[i]+512)&2047])>>2);
		clipmove(&spritex[i],&spritey[i],xvect,yvect,2097152,2);
		spriteang[i] = ((spriteang[i]+sprite[i].angvel)&2047);

			 //Check if the bullet hit any players
		for(j=connecthead;j>=0;j=connectpoint2[j])
			if (klabs(spritex[i]-posx[j]) < 6291456)
				if (klabs(spritey[i]-posy[j]) < 6291456)
					if (sprite[i].owner != j+4096)
						if (health[j] >= 0)
						{
							wsayfollow("ouch.wav",4096L+(krand()&511)-256,256L,&spritex[i],&spritey[i],0);
							health[j] -= 1024;
							if (health[j] < 0)
							{
								explode((short)j+4096,16,EXPLOSION);
								deadspinx[j] = posx[j];
								deadspiny[j] = posy[j];
								wsayfollow("death.wav",4096L,256L,&spritex[i],&spritey[i],1);
								health[j] = -1;
							}
							deletesprite(i);
							goto nextsprite2;
						}

			//Check if bullet hit any monsters
		j = headsprite[1];
		while (j != -1)
		{
			nextj = nextsprite[j];

			if (klabs(spritex[i]-spritex[j]) < 6291456)
				if (klabs(spritey[i]-spritey[j]) < 6291456)
					if (sprite[i].owner != j)
						switch(spritepicnum[j])
						{
							case AIRPLANE:
								sprite[j].health -= 1024;
								if (sprite[j].health < 0)
								{
									spritepicnum[j] = BURNINGAIRPLANE;
									spritezoom[j] = 49152;
									sprite[j].vel = 0;
									sprite[j].angvel = 0;
									explode((short)j,32,EXPLOSION);
									if (sprite[i].owner >= 4096)
										wsayfollow("blowup.wav",3584L,256L,&spritex[j],&spritey[j],1);
								}
								else if (sprite[i].owner >= 4096)
								{
									wsayfollow("bullseye.wav",4096L+(krand()&511)-256,256L,&spritex[j],&spritey[j],1);
									sprite[j].time = totalclock+8;    //Flashtime
								}

								deletesprite(i);
								goto nextsprite2;
							case CAR:
								sprite[j].health -= 2048;
								if (sprite[j].health < 0)
								{
									sprite[j].angvel = 0;
									explode((short)j,8,EXPLOSION);
									spritepicnum[j] = BROKENCAR;
									if (sprite[i].owner >= 4096)
										wsayfollow("blowup.wav",4096L,256L,&spritex[j],&spritey[j],1);
								}
								else if (sprite[i].owner >= 4096)
								{
									wsayfollow("bullseye.wav",4096L+(krand()&511),256L,&spritex[j],&spritey[j],1);
									sprite[j].time = totalclock+8;    //Flashtime
								}

								deletesprite(i);
								goto nextsprite2;
							case CAR2:
								if (sprite[i].owner < 4096)    //Don't want car2 to disappear too quickly!
									sprite[j].health -= 1024;
								else
									sprite[j].health -= 16384;
								if (sprite[j].health < 0)
								{
									sprite[j].angvel = 0;
									explode((short)j,8,EXPLOSION);
									spritepicnum[j] = BROKENCAR2;
									if (sprite[i].owner >= 4096)
										wsayfollow("blowup.wav",4608L,256L,&spritex[j],&spritey[j],1);
								}
								deletesprite(i);
								goto nextsprite2;
							case SKATEBOARDDUDE:
								if (sprite[i].owner >= 4096)    //Only a player can kill him!
								{
									sprite[j].angvel = 0;
									explode((short)j,16,BODYPART);
									wsayfollow("explode.wav",4096L,256L,&spritex[j],&spritey[j],1);
									deletesprite(j);
									goto nextsprite2;
								}
						}

			j = nextj;
		}

nextsprite2:
		i = nexti;
	}

	i = headsprite[3];
	while (i != -1)                      //Go through explosion sprites
	{
		nexti = nextsprite[i];

		ospritex[i] = spritex[i];
		ospritey[i] = spritey[i];
		ospriteang[i] = spriteang[i];
		ospritezoom[i] = spritezoom[i];

		if ((sprite[i].owner >= 0) && (sprite[i].owner < 4096))
			if (spritestat[sprite[i].owner] < MAXSTATUS)
			{
					//Keep momentum while dying
				j = sprite[sprite[i].owner].vel*TICSPERFRAME;
				spritex[i] += ((j*sintable[spriteang[sprite[i].owner]])>>3);
				spritey[i] += ((-j*sintable[(spriteang[sprite[i].owner]+512)&2047])>>3);
			}
		j = sprite[i].vel*TICSPERFRAME;
		spritex[i] += ((j*sintable[spriteang[i]])>>2);
		spritey[i] += ((-j*sintable[(spriteang[i]+512)&2047])>>2);
		spriteang[i] = ((spriteang[i]+sprite[i].angvel)&2047);
		spritezoom[i] -= (TICSPERFRAME<<9);

		if ((lockclock > sprite[i].time+240) || (spritezoom[i] <= 16))
		{
			deletesprite(i);
			goto nextsprite3;
		}

nextsprite3:
		i = nexti;
	}

		//Go through players
	for(k=connecthead;k>=0;k=connectpoint2[k])
		processinput((short)k,&syn[k]);

	fakedomovethingscorrect();
}

processinput(short snum, input *syn)
{
	long x, y, xvect, yvect;
	short i, j, movez, mousx, mousy, mstrafe;

	if (health[snum] < 0)
	{
		health[snum] -= TICSPERFRAME;
		if (health[snum] <= -256)
		{
			warptorandomspot(&posx[snum],&posy[snum],&ang[snum]);
			health[snum] = 16383;
		}
		else
		{
			xvect = (((long)sintable[(-ang[snum])&2047])*((long)vel[snum]));
			yvect = (((long)sintable[(2560-ang[snum])&2047])*((long)vel[snum]));
			xvect += (((long)sintable[(2560-ang[snum])&2047])*((long)svel[snum]));
			yvect += (((long)sintable[(1024-ang[snum])&2047])*((long)svel[snum]));
			clipmove(&deadspinx[snum],&deadspiny[snum],xvect,yvect,2097152,1);
		}
		return;
	}

	mousx = syn[0].mousx;
	mousy = (((short)syn[0].mousy)<<3);
	mstrafe = 0;

	if (((syn[0].bits&256) > 0) || ((syn[0].bits&16384) != 0))   //Rt. Ctrl or Rt. mouse button
	{
		mstrafe = (mousx<<3);
		mousx = 0;
		if ((syn[0].bits&8) > 0) mstrafe -= (TICSPERFRAME<<(4+((syn[0].bits&128)>0)));
		if ((syn[0].bits&16) > 0) mstrafe += (TICSPERFRAME<<(4+((syn[0].bits&128)>0)));
	}
	else                       //Else turn
	{
		if ((syn[0].bits&8) > 0) mousx -= (TICSPERFRAME<<(2+((syn[0].bits&128)>0)));
		if ((syn[0].bits&16) > 0) mousx += (TICSPERFRAME<<(2+((syn[0].bits&128)>0)));
	}                          //Move forward / backward
	if ((syn[0].bits&2) > 0) mousy -= (TICSPERFRAME<<(4+((syn[0].bits&128)>0)));
	if ((syn[0].bits&4) > 0) mousy += (TICSPERFRAME<<(4+((syn[0].bits&128)>0)));

	i = angvel[snum];
	angvel[snum] = ((angvel[snum]*3+mousx)>>2);
	if (i == angvel[snum])
	{
		if (mousx < angvel[snum]) angvel[snum]--;
		if (mousx > angvel[snum]) angvel[snum]++;
	}
	i = vel[snum];
	vel[snum] = ((i*3+mousy)>>2);
	if (i == vel[snum])
	{
		if (mousy < vel[snum]) vel[snum]--;
		if (mousy > vel[snum]) vel[snum]++;
	}
	i = svel[snum];
	svel[snum] = ((i*3+mstrafe)>>2);
	if (i == svel[snum])
	{
		if (mstrafe < svel[snum]) svel[snum]--;
		if (mstrafe > svel[snum]) svel[snum]++;
	}

	ang[snum] = ((ang[snum]+angvel[snum])&2047);
	xvect = (((long)sintable[(-ang[snum])&2047])*((long)vel[snum]));
	yvect = (((long)sintable[(2560-ang[snum])&2047])*((long)vel[snum]));
	xvect += (((long)sintable[(2560-ang[snum])&2047])*((long)svel[snum]));
	yvect += (((long)sintable[(1024-ang[snum])&2047])*((long)svel[snum]));
	clipmove(&posx[snum],&posy[snum],xvect,yvect,2097152,1);   //Actually move player!

	movez = 0;
	if ((syn[0].bits&32) > 0) movez -= (TICSPERFRAME<<(7+(((syn[0].bits&128)>0)<<1)));
	if ((syn[0].bits&64) > 0) movez += (TICSPERFRAME<<(7+(((syn[0].bits&128)>0)<<1)));

	i = zoomvel[snum];
	zoomvel[snum] = ((i*3+movez)>>2);
	if (i == zoomvel[snum])
	{
		if (movez < zoomvel[snum]) zoomvel[snum]--;
		if (movez > zoomvel[snum]) zoomvel[snum]++;
	}
	zoom[snum] += zoomvel[snum];
	if (zoom[snum] < 16384) zoom[snum] = 16384;
	if (zoom[snum] > 1048576) zoom[snum] = 1048576;

	if ((syn[0].bits&(512+32768)) > 0)  //Left CTRL or Left mouse button
		if (lockclock > lastshoottime[snum]+20)
		{
			lastshoottime[snum] = lockclock;
			shootbullet(snum+4096);                 //You shoot a bullet!
		}

	if ((syn[0].bits&4096) > 0)                    //Space bar
	{
		x = ((posx[snum]>>23)&63);
		y = ((posy[snum]>>23)&63);
		i = board2d[(x<<6)+y];

		if (board2d[((x+1)<<6)+y] == LOCKEDBLOCK) x++;
		else if (board2d[((x-1)<<6)+y] == LOCKEDBLOCK) x--;
		else if (board2d[(x<<6)+(y+1)] == LOCKEDBLOCK) y++;
		else if (board2d[(x<<6)+(y-1)] == LOCKEDBLOCK) y--;

		board2d[(x<<6)+y] = i;

		if (board2d[((x+1)<<6)+y] == LOCKEDBLOCK)
			board2d[((x+1)<<6)+y] = i;
		else if (board2d[((x-1)<<6)+y] == LOCKEDBLOCK)
			board2d[((x-1)<<6)+y] = i;
		else if (board2d[(x<<6)+(y+1)] == LOCKEDBLOCK)
			board2d[(x<<6)+(y+1)] = i;
		else if (board2d[(x<<6)+(y-1)] == LOCKEDBLOCK)
			board2d[(x<<6)+(y-1)] = i;
	}

	if ((syn[0].bits&1024) > 0)   //PGUP - Jump to last level
	{
		if ((prepboardflag[snum]&1) == 0)
		{
			boardnum--; if (boardnum < 0) boardnum = nummaps-1;
			prepboardflag[snum] |= 1;
			ready2send = 0;
			prepareboard(boardfilename,boardnum);
			ready2send = 1;
		}
	}
	else
		prepboardflag[snum] &= ~1;

	if ((syn[0].bits&2048) > 0)   //PGDN - Jump to next level
	{
		if ((prepboardflag[snum]&2) == 0)
		{
			boardnum++; if (boardnum >= nummaps) boardnum = 0;
			prepboardflag[snum] |= 2;
			ready2send = 0;
			prepareboard(boardfilename,boardnum);
			ready2send = 1;
		}
	}
	else
		prepboardflag[snum] &= ~2;

	if (typemode == 0)           //if normal game keys active
	{
		if (keystatus[keys[18]] > 0)   //Tab
		{
			keystatus[keys[18]] = 0;
			typemode = 1;
		}
	}
	else
	{
		for(i=0;i<128;i++)
			if (keystatus[i] > 0)
			{
				if ((keystatus[0x2a]|keystatus[0x36]) > 0)
				{
					if (scantoascwithshift[i] != 0)
					{
						if (typemessageleng < 159-4*4)
							typemessage[typemessageleng++] = scantoascwithshift[i];
						keystatus[i] = 0;
					}
				}
				else
				{
					if (scantoasc[i] != 0)
					{
						if (typemessageleng < 159-4*4)
							typemessage[typemessageleng++] = scantoasc[i];
						keystatus[i] = 0;
					}
				}
			}

		if (keystatus[0xe] > 0)   //Backspace
		{
				//Here's a trick of making key repeat after a 1/2 second
			if ((keystatus[0xe] == 1) || (keystatus[0xe] == 60))
			{
				if (typemessageleng > 0)
					typemessageleng--;
				else
					typemessageleng = 0, typemode = 0;
			}
			if (keystatus[0xe] < 60)
			{
				keystatus[0xe] += TICSPERFRAME;
				if (keystatus[0xe] > 60) keystatus[0xe] = 60;
			}
		}

		if ((keystatus[0x1c]|keystatus[0x9c]) > 0)  //Either ENTER
		{
			if (typemessageleng > 0)
			{
				i = 0;
				tempbuf[i++] = 2;          //Sending text is message type 2
				for(j=0;j<typemessageleng;j++)
					tempbuf[i++] = typemessage[j];

				for(j=connecthead;j>=0;j=connectpoint2[j])
					if (j != myconnectindex)
						sendpacket(j,tempbuf,i);
			}

			typemessageleng = 0;
			keystatus[0x1c] = 0;
			keystatus[0x9c] = 0;
			typemode = 0;
		}

		if ((keystatus[0xf]) > 0) //Tab
		{
			keystatus[0xf] = 0;
			typemode = 0;
		}
	}
}

shootbullet(short owner)
{
	long i, j;

	j = insertsprite(2);
	sprite[j].time = lockclock;
	sprite[j].owner = owner;

	if ((owner >= 0) && (owner < 4096))
	{
		spritex[j] = spritex[owner];
		spritey[j] = spritey[owner];
		spriteang[j] = spriteang[owner];

		if (spritepicnum[owner] == AIRPLANE)
		{
			spritezoom[j] = 65536+32768;
			spritepicnum[j] = BULLET;
			sprite[j].vel = 192;
			sprite[j].angvel = 0;
		}
		if (spritepicnum[owner] == CAR)
		{
			spritezoom[j] = 65536;
			spritepicnum[j] = BULLET;
			sprite[j].vel = 128;
			sprite[j].angvel = 0;
		}
		if (spritepicnum[owner] == CAR2)
		{
			spritezoom[j] = 32768;
			spritepicnum[j] = BULLET;
			sprite[j].vel = 64;
			sprite[j].angvel = 0;
		}
	}
	else if (owner >= 4096)
	{
		spritex[j] = posx[owner-4096];
		spritey[j] = posy[owner-4096];
		spriteang[j] = ang[owner-4096];
		spritezoom[j] = 65536;
		spritepicnum[j] = SILVERBULLET;
		sprite[j].vel = 128;
		sprite[j].angvel = 0;
		wsayfollow("zipguns.wav",4096L,128L,&spritex[j],&spritey[j],1);
	}
	ospritex[j] = spritex[j];
	ospritey[j] = spritey[j];
	ospritezoom[j] = spritezoom[j];
	ospriteang[j] = spriteang[j];
}

explode(short owner, short numfragments, short dapicnum)
{
	long i, j;

	for(i=0;i<numfragments;i++)
	{
		j = insertsprite(3);
		if (owner >= 4096)
		{
			spritex[j] = posx[owner-4096];
			spritey[j] = posy[owner-4096];
		}
		else if (owner >= 0)
		{
			spritex[j] = spritex[owner];
			spritey[j] = spritey[owner];
		}
		spritezoom[j] = 65536;
		spriteang[j] = (krand()&2047);
		spritepicnum[j] = dapicnum;
		sprite[j].vel = (krand()&63);
		sprite[j].angvel = (krand()&63)-32;
		sprite[j].time = lockclock;
		sprite[j].owner = owner;

		ospritex[j] = spritex[j];
		ospritey[j] = spritey[j];
		ospritezoom[j] = spritezoom[j];
		ospriteang[j] = spriteang[j];
	}
}

warptorandomspot(long *x, long *y, short *ang)
{
	long i;

	do
	{
		i = (krand()&4095);
	}
	while (((picanm[board2d[i]]>>24)&255) != 0);
	*x = ((i>>6)<<23)+4194304;
	*y = ((i&63)<<23)+4194304;
	*ang = (krand()&0x600);
}

loadpalette(char filename[20])
{
	long i, fil;

	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&palette[0],768);
		close(fil);
	}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
}

setviewboundaries()
{
	long i;

	setview(32L,0L,(long)xdim-1,(long)ydim-1);
	pivotx = ((xdim+32)>>1); //Screen coordinate pivot point that whole screen
	pivoty = ydim-32;        //rotates around (used to be 160, 100)
}

prepareboard(char *boardfilename, short daboardnum)
{
	long i, j, nextj;

	waitforeverybody();

	randomseed = 17L;

	typemode = 0;

	load2board(boardfilename,daboardnum,&posx[0],&posy[0],&zoom[0],&ang[0]);
	for(i=0;i<MAXPLAYERS;i++)
	{
		posx[i] = posx[0];
		posy[i] = posy[0];
		zoom[i] = zoom[0];
		ang[i] = ang[0];
		oposx[i] = posx[0];
		oposy[i] = posy[0];
		ozoom[i] = zoom[0];
		oang[i] = ang[0];
	}

	j = headsprite[1];                      //Set up sprite variables
	while (j != -1)
	{
		nextj = nextsprite[j];

		sprite[j].health = 16383;
		sprite[j].time = -1;
		sprite[j].angvel = 0;
		sprite[j].vel = 0;
		sprite[j].owner = -1;

		ospritex[j] = spritex[j];
		ospritey[j] = spritey[j];
		ospritezoom[j] = spritezoom[j];
		ospriteang[j] = spriteang[j];

		if (spritepicnum[j] == AIRPLANE)
		{
			sprite[j].vel = 100;
			sprite[j].angvel = 0;
			changespritestat(j,1);
		}
		else if ((spritepicnum[j] == CAR) || (spritepicnum[j] == CAR2) || (spritepicnum[j] == SKATEBOARDDUDE))
		{
			sprite[j].vel = 50;
			sprite[j].angvel = (krand()&15)-8;
			changespritestat(j,1);
		}
		else if ((spritepicnum[j] == COIN) || (spritepicnum[j] == SUPERSPIRAL))
		{
			sprite[j].angvel = ((((spritex[j]>>23)&1)^((spritey[j]>>23)&1))<<1)-1;
			if (spritepicnum[j] == COIN) sprite[j].angvel <<= 4;
			if (spritepicnum[j] == SUPERSPIRAL) sprite[j].angvel <<= 5;
			changespritestat(j,0);
		}

		j = nextj;
	}

	movefifoplc = movefifosendplc = fakemovefifoplc = 0;

	for(i=0;i<MAXPLAYERS;i++) syncvalhead[i] = 0L;
	syncvaltail = 0L;
	syncvaltottail = 0L;

	myx = omyx = posx[myconnectindex];
	myy = omyy = posy[myconnectindex];
	myzoom = omyzoom = zoom[myconnectindex];
	myang = omyang = ang[myconnectindex];
	myvel = vel[myconnectindex];
	mysvel = svel[myconnectindex];
	myzoomvel = zoomvel[myconnectindex];
	myangvel = angvel[myconnectindex];

	for(i=0;i<MAXPLAYERS;i++)
	{
		movefifoend[i] = 0;
		vel[i] = 0;
		svel[i] = 0;
		zoomvel[i] = 0;
		angvel[i] = 0;
		health[i] = 16383;                       //Initialize my variables
		lastshoottime[i] = 0;
	}

	clearbufbyte(inputfifo,sizeof(input)*MOVEFIFOSIZ*MAXPLAYERS,0L);

	for(i=connecthead;i>=0;i=connectpoint2[i]) myminlag[i] = 0;
	otherminlag = mymaxlag = 0;

	waitforeverybody();

	clearbufbyte(playerquitflag,sizeof(playerquitflag),0L);

	lockclock = 0;
	totalclock = 0;
	ototalclock = 0;
	masterslavetexttime = 0;
}

playback()
{
	long i, j, k, recplay;

	if ((recfil = open("demo.rec",O_BINARY|O_RDWR,S_IREAD)) == -1) return;
	read(recfil,&reccnt,4);
	read(recfil,&numplayers,2);
	read(recfil,&myconnectindex,2);
	read(recfil,&connecthead,2);
	read(recfil,&connectpoint2,sizeof(connectpoint2));

	ready2send = 0;
	recstat = 0; recplay = 0;
	while (keystatus[1] == 0)
	{
		while (totalclock >= ototalclock+(TIMERINTSPERSECOND/MOVESPERSECOND))
		{
			if (!recplay) { boardnum = 0; prepareboard(boardfilename,boardnum); }
			for(j=connecthead;j>=0;j=connectpoint2[j])
			{
				if (!(recplay&(RECBUFSIZ-1)))
					read(recfil,recbuf,min(sizeof(recbuf),(reccnt-recplay)*sizeof(input)));
				copybufbyte(&recbuf[recplay&(RECBUFSIZ-1)],&inputfifo[movefifoend[j]&(MOVEFIFOSIZ-1)][j],sizeof(input));
				movefifoend[j]++;
				recplay++;
				if (recplay >= reccnt) { lseek(recfil,4+2+2+2+sizeof(connectpoint2),SEEK_SET); recplay = 0; }
			}
			ototalclock += (TIMERINTSPERSECOND/MOVESPERSECOND);
			domovethings();
		}
		drawscreen(screenpeek,(totalclock-ototalclock)*(65536/(TIMERINTSPERSECOND/MOVESPERSECOND)));

		if (keystatus[keys[15]] > 0)
		{
			keystatus[keys[15]] = 0;
			screenpeek = connectpoint2[screenpeek];
			if (screenpeek < 0) screenpeek = connecthead;
		}
	}
	close(recfil);
}

inittimer()
{
	outp(0x43,0x34);
	outp(0x40,(1193181/TIMERINTSPERSECOND)&255);
	outp(0x40,(1193181/TIMERINTSPERSECOND)>>8);
	oldtimerhandler = _dos_getvect(0x8);
	_disable(); _dos_setvect(0x8, timerhandler); _enable();
}

uninittimer()
{
	outp(0x43,0x34); outp(0x40,0); outp(0x40,0);
	_disable(); _dos_setvect(0x8, oldtimerhandler); _enable();
}

void __interrupt __far timerhandler()
{
	totalclock++;
	_chain_intr(oldtimerhandler);
	outp(0x20,0x20);
}

faketimerhandler()
{
	long i, j, k, l;
	input *osyn, *nsyn;

	if ((totalclock < ototalclock+(TIMERINTSPERSECOND/MOVESPERSECOND)) || (ready2send == 0)) return;
	ototalclock += (TIMERINTSPERSECOND/MOVESPERSECOND);

	getpackets(); if (getoutputcirclesize() >= 16) return;

	for(i=connecthead;i>=0;i=connectpoint2[i])
		if ((i != myconnectindex) && (!playerquitflag[i]))
			if (movefifoend[i] < movefifoend[myconnectindex]-200) return;

	getinput(&loc);
	avgmousx += loc.mousx;
	avgmousy += loc.mousy;
	avgbits |= loc.bits;
	if (movefifoend[myconnectindex]&(movesperpacket-1))
	{
		copybufbyte(&inputfifo[(movefifoend[myconnectindex]-1)&(MOVEFIFOSIZ-1)][myconnectindex],
						&inputfifo[movefifoend[myconnectindex]&(MOVEFIFOSIZ-1)][myconnectindex],sizeof(input));
		movefifoend[myconnectindex]++;
		return;
	}
	nsyn = &inputfifo[movefifoend[myconnectindex]&(MOVEFIFOSIZ-1)][myconnectindex];
	nsyn[0].mousx = avgmousx / movesperpacket; avgmousx = 0;
	nsyn[0].mousy = avgmousy / movesperpacket; avgmousy = 0;
	nsyn[0].bits = avgbits; avgbits = 0;
	movefifoend[myconnectindex]++;

	if (numplayers < 2) return;

	for(i=connecthead;i>=0;i=connectpoint2[i])
		if (i != myconnectindex)
		{
			k = (movefifoend[myconnectindex]-1)-movefifoend[i];
			myminlag[i] = min(myminlag[i],k);
			mymaxlag = max(mymaxlag,k);
		}

	if (((movefifoend[myconnectindex]-1)&(TIMERUPDATESIZ-1)) == 0)
	{
		i = mymaxlag-bufferjitter; mymaxlag = 0;
		if (i > 0) bufferjitter += ((2+i)>>2);
		else if (i < 0) bufferjitter -= ((2-i)>>2);
	}

	if (networkmode == 1)
	{
		packbuf[0] = 17;
		//if ((movefifoend[myconnectindex]-1) == 0) packbuf[0] = 16;
		j = 1;

			//Fix timers and buffer/jitter value
		if (((movefifoend[myconnectindex]-1)&(TIMERUPDATESIZ-1)) == 0)
		{
			if (myconnectindex == connecthead)
			{
				for(i=connectpoint2[connecthead];i>=0;i=connectpoint2[i])
					packbuf[j++] = min(max(myminlag[i],-128),127);
			}
			else
			{
				i = myminlag[connecthead]-otherminlag;
				if (klabs(i) > 2)
				{
					if (klabs(i) > 8)
					{
						if (i < 0) i++;
						i >>= 1;
					}
					else i = ksgn(i);
					totalclock -= TICSPERFRAME*i;
					otherminlag += i;
				}
			}
			for(i=connecthead;i>=0;i=connectpoint2[i])
				myminlag[i] = 0x7fffffff;
		}

		osyn = (input *)&inputfifo[(movefifoend[myconnectindex]-2)&(MOVEFIFOSIZ-1)][myconnectindex];
		nsyn = (input *)&inputfifo[(movefifoend[myconnectindex]-1)&(MOVEFIFOSIZ-1)][myconnectindex];

		k = j;
		packbuf[j++] = 0;
		if (nsyn[0].mousx != osyn[0].mousx) packbuf[j++] = nsyn[0].mousx, packbuf[k] |= 1;
		if (nsyn[0].mousy != osyn[0].mousy) packbuf[j++] = nsyn[0].mousy, packbuf[k] |= 2;
		if ((nsyn[0].bits^osyn[0].bits)&0x00ff) packbuf[j++] = (nsyn[0].bits&255), packbuf[k] |= 4;
		if ((nsyn[0].bits^osyn[0].bits)&0xff00) packbuf[j++] = ((nsyn[0].bits>>8)&255), packbuf[k] |= 8;

		while (syncvalhead[myconnectindex] != syncvaltail)
		{
			packbuf[j++] = syncval[myconnectindex][syncvaltail&(MOVEFIFOSIZ-1)];
			syncvaltail++;
		}

		for(i=connecthead;i>=0;i=connectpoint2[i])
			if (i != myconnectindex)
				sendpacket(i,packbuf,j);

		return;
	}
	if (myconnectindex != connecthead)   //Slave
	{
			//Fix timers and buffer/jitter value
		if (((movefifoend[myconnectindex]-1)&(TIMERUPDATESIZ-1)) == 0)
		{
			i = myminlag[connecthead]-otherminlag;
			if (klabs(i) > 2)
			{
				if (klabs(i) > 8)
				{
					if (i < 0) i++;
					i >>= 1;
				}
				else i = ksgn(i);
				totalclock -= TICSPERFRAME*i;
				otherminlag += i;
			}

			for(i=connecthead;i>=0;i=connectpoint2[i])
				myminlag[i] = 0x7fffffff;
		}

		packbuf[0] = 1; j = 2; k = 0;

		osyn = (input *)&inputfifo[(movefifoend[myconnectindex]-2)&(MOVEFIFOSIZ-1)][myconnectindex];
		nsyn = (input *)&inputfifo[(movefifoend[myconnectindex]-1)&(MOVEFIFOSIZ-1)][myconnectindex];

		if (nsyn[0].mousx != osyn[0].mousx) packbuf[j++] = nsyn[0].mousx, k |= 1;
		if (nsyn[0].mousy != osyn[0].mousy) packbuf[j++] = nsyn[0].mousy, k |= 2;
		if ((nsyn[0].bits^osyn[0].bits)&0x00ff) packbuf[j++] = (nsyn[0].bits&255), k |= 4;
		if ((nsyn[0].bits^osyn[0].bits)&0xff00) packbuf[j++] = ((nsyn[0].bits>>8)&255), k |= 8;
		packbuf[1] = k;

		while (syncvalhead[myconnectindex] != syncvaltail)
		{
			packbuf[j++] = syncval[myconnectindex][syncvaltail&(MOVEFIFOSIZ-1)];
			syncvaltail++;
		}

		sendpacket(connecthead,packbuf,j);
		return;
	}

		//This allows packet-resends
	for(i=connecthead;i>=0;i=connectpoint2[i])
		if ((!playerquitflag[i]) && (movefifoend[i] <= movefifosendplc))
		{
			packbuf[0] = 127;
			for(i=connectpoint2[connecthead];i>=0;i=connectpoint2[i])
				if (!playerquitflag[i]) sendpacket(i,packbuf,1);
			return;
		}

	while (1)  //Master
	{
		for(i=connecthead;i>=0;i=connectpoint2[i])
			if ((!playerquitflag[i]) && (movefifoend[i] <= movefifosendplc)) return;

		osyn = (input *)&inputfifo[(movefifosendplc-1)&(MOVEFIFOSIZ-1)][0];
		nsyn = (input *)&inputfifo[(movefifosendplc  )&(MOVEFIFOSIZ-1)][0];

			//MASTER -> SLAVE packet
		packbuf[0] = 0; j = 1;

			//Fix timers and buffer/jitter value
		if ((movefifosendplc&(TIMERUPDATESIZ-1)) == 0)
		{
			for(i=connectpoint2[connecthead];i>=0;i=connectpoint2[i])
				if (!playerquitflag[i])
					packbuf[j++] = min(max(myminlag[i],-128),127);

			for(i=connecthead;i>=0;i=connectpoint2[i])
				myminlag[i] = 0x7fffffff;
		}

		for(i=connecthead;i>=0;i=connectpoint2[i])
		{
			if (playerquitflag[i]) continue;
			k = j++;
			l = 0;
			if (osyn[i].mousx != nsyn[i].mousx) packbuf[j++] = nsyn[i].mousx, l |= 1;
			if (osyn[i].mousy != nsyn[i].mousy) packbuf[j++] = nsyn[i].mousy, l |= 2;
			if ((osyn[i].bits^nsyn[i].bits)&0x00ff) packbuf[j++] = (nsyn[i].bits&255), l |= 4;
			if ((osyn[i].bits^nsyn[i].bits)&0xff00) packbuf[j++] = ((nsyn[i].bits>>8)&255), l |= 8;
			packbuf[k] = l;
		}

		while (syncvalhead[myconnectindex] != syncvaltail)
		{
			packbuf[j++] = syncval[myconnectindex][syncvaltail&(MOVEFIFOSIZ-1)];
			syncvaltail++;
		}

		for(i=connectpoint2[connecthead];i>=0;i=connectpoint2[i])
			if (!playerquitflag[i])
			{
				sendpacket(i,packbuf,j);
				if (nsyn[i].bits&1) playerquitflag[i] = 1;
			}

		movefifosendplc += movesperpacket;
	}
}

getpackets()
{
	long i, j, k, l;
	short other, packbufleng;
	input *osyn, *nsyn;
	char *ptr;

	if (numplayers < 2) return;
	while ((packbufleng = getpacket(&other,packbuf)) > 0)
	{
		switch(packbuf[0])
		{
			case 0:  //[0] (receive master sync buffer)
				j = 1;

				if ((movefifoend[other]&(TIMERUPDATESIZ-1)) == 0)
					for(i=connectpoint2[connecthead];i>=0;i=connectpoint2[i])
					{
						if (playerquitflag[i]) continue;
						if (i == myconnectindex)
							otherminlag = (long)((signed char)packbuf[j]);
						j++;
					}

				osyn = (input *)&inputfifo[(movefifoend[connecthead]-1)&(MOVEFIFOSIZ-1)][0];
				nsyn = (input *)&inputfifo[(movefifoend[connecthead])&(MOVEFIFOSIZ-1)][0];

				for(i=connecthead;i>=0;i=connectpoint2[i])
				{
					if (playerquitflag[i]) continue;
					l = packbuf[j++];
					if (i == myconnectindex)
						{ j += (l&1)+((l&2)>>1)+((l&4)>>2)+((l&8)>>3); continue; }

					copybufbyte(&osyn[i],&nsyn[i],sizeof(input));
					if (l&1) nsyn[i].mousx = packbuf[j++];
					if (l&2) nsyn[i].mousy = packbuf[j++];
					if (l&4) nsyn[i].bits = (nsyn[i].bits&0xff00)+packbuf[j++];
					if (l&8) nsyn[i].bits = (nsyn[i].bits&0x00ff)+(packbuf[j++]<<8);
					if (nsyn[i].bits&1) playerquitflag[i] = 1;
					movefifoend[i]++;
				}

				while (j != packbufleng)
				{
					for(i=connecthead;i>=0;i=connectpoint2[i])
						if (i != myconnectindex)
						{
							syncval[i][syncvalhead[i]&(MOVEFIFOSIZ-1)] = packbuf[j];
							syncvalhead[i]++;
						}
					j++;
				}

				for(i=connecthead;i>=0;i=connectpoint2[i])
					if (i != myconnectindex)
						for(j=1;j<movesperpacket;j++)
						{
							copybufbyte(&nsyn[i],&inputfifo[movefifoend[i]&(MOVEFIFOSIZ-1)][i],sizeof(input));
							movefifoend[i]++;
						}

				break;
			case 1:  //[1] (receive slave sync buffer)
				j = 2; k = packbuf[1];

				osyn = (input *)&inputfifo[(movefifoend[other]-1)&(MOVEFIFOSIZ-1)][0];
				nsyn = (input *)&inputfifo[(movefifoend[other])&(MOVEFIFOSIZ-1)][0];

				copybufbyte(&osyn[other],&nsyn[other],sizeof(input));
				if (k&1) nsyn[other].mousx = packbuf[j++];
				if (k&2) nsyn[other].mousy = packbuf[j++];
				if (k&4) nsyn[other].bits = ((nsyn[other].bits&0xff00)|((short)packbuf[j++]));
				if (k&8) nsyn[other].bits = ((nsyn[other].bits&0x00ff)|(((short)packbuf[j++])<<8));
				movefifoend[other]++;

				while (j != packbufleng)
				{
					syncval[other][syncvalhead[other]&(MOVEFIFOSIZ-1)] = packbuf[j++];
					syncvalhead[other]++;
				}

				for(i=1;i<movesperpacket;i++)
				{
					copybufbyte(&nsyn[other],&inputfifo[movefifoend[other]&(MOVEFIFOSIZ-1)][other],sizeof(input));
					movefifoend[other]++;
				}

				break;
			case 2:
				getmessageleng = packbufleng-1;
				for(j=getmessageleng-1;j>=0;j--) getmessage[j] = packbuf[j+1];
				getmessagetimeoff = totalclock+360+(getmessageleng<<4);
				break;
			case 3:
				ptr = (char *)(precsndoffs+precording);
				for(i=0;i<512;i++) ptr[i] = packbuf[i+1];
				precording += 512;
				break;
			case 4:
				ptr = (char *)(precsndoffs);
				while (precording < RECSNDSIZ) ptr[precording++] = 128;
				wsay("precordedvoice",2972L,255L,255L);
				precording = 0;
				break;
			//case 16:
				//movefifoend[other] = movefifoplc = movefifosendplc = fakemovefifoplc = 0;
				//syncvalhead[other] = syncvaltottail = 0;
			case 17:
				j = 1;

				if ((movefifoend[other]&(TIMERUPDATESIZ-1)) == 0)
					if (other == connecthead)
						for(i=connectpoint2[connecthead];i>=0;i=connectpoint2[i])
						{
							if (i == myconnectindex)
								otherminlag = (long)((signed char)packbuf[j]);
							j++;
						}

				osyn = (input *)&inputfifo[(movefifoend[other]-1)&(MOVEFIFOSIZ-1)][0];
				nsyn = (input *)&inputfifo[(movefifoend[other])&(MOVEFIFOSIZ-1)][0];

				copybufbyte(&osyn[other],&nsyn[other],sizeof(input));
				k = packbuf[j++];
				if (k&1) nsyn[other].mousx = packbuf[j++];
				if (k&2) nsyn[other].mousy = packbuf[j++];
				if (k&4) nsyn[other].bits = ((nsyn[other].bits&0xff00)|((short)packbuf[j++]));
				if (k&8) nsyn[other].bits = ((nsyn[other].bits&0x00ff)|(((short)packbuf[j++])<<8));
				movefifoend[other]++;

				for(i=1;i<movesperpacket;i++)
				{
					copybufbyte(&nsyn[other],&inputfifo[movefifoend[other]&(MOVEFIFOSIZ-1)][other],sizeof(input));
					movefifoend[other]++;
				}

				if (j > packbufleng) { printf("INVALID GAME PACKET!!!\n"); break; }

				while (j != packbufleng)
				{
					syncval[other][syncvalhead[other]&(MOVEFIFOSIZ-1)] = packbuf[j++];
					syncvalhead[other]++;
				}

				break;
			case 250:
				playerreadyflag[other]++;
				break;
			case 255:  //[255] (logout)
				keystatus[1] = 1;
				break;
		}
	}
}

waitforeverybody()
{
	long i;
	short other;

	if (numplayers < 2) return;

	packbuf[0] = 250;
	for(i=connecthead;i>=0;i=connectpoint2[i])
		if (i != myconnectindex)
			sendpacket(i,packbuf,1);

	playerreadyflag[myconnectindex]++;
	while (1)
	{
		if (keystatus[1]) cleanexit();

		getpackets();

		for(i=connecthead;i>=0;i=connectpoint2[i])
			if (playerreadyflag[i] < playerreadyflag[myconnectindex]) break;
		if (i < 0) return;
	}
}
